
			
;Game actions like using items, talking to people etc. are stored here
;----------------------
EmptyTrashcanIntoToilet
;check if trashcan held
	LD A,(ChosenItem)
	CP 1
	JP NZ,ItemEvents				;if not, go to pick/drop item
;check if trashcan full of rubbish
	LD HL,TrashcanStatus
	LD A,(HL)
	OR A							;0=full of rubbish
	JP NZ,ItemEvents	
;change trashcan status
	INC (HL)						;status =1
;comment	
	LD A,1							;message number	
	CALL TypeMessage
	CALL IncreaseScore
	RET ;return to key reading routine

;----------------------
FillTrashcanWithWater
;check if trashcan held
	LD A,(ChosenItem)
	CP 1
	JP NZ,ItemEvents				;if not, go to pick/drop item
;check if trashcan empty
	LD HL,TrashcanStatus
	LD A,(HL)
	CP 1							;1=empty
	JP NZ,ItemEvents		
;change trashcan status
	INC (HL)						;status =2		
;comment
	LD A,2	
	CALL TypeMessage
	CALL IncreaseScore
	RET

;----------------------
GoMyWindow
	LD HL,MyWindowStatus
	LD A,(HL)
	OR A
	JR NZ,GoMyWindow2	
									;0 = first see the window, display info
	INC (HL)						;change status to 1
	LD A,28
	CALL TypeMessage
	RET

GoMyWindow2
	CP 1
	JR Z,GoMyWindow3					;status=1, Alice not met, go through window
	CP 3
	JR Z,GoMyWindow3					;status=3, Alice rescued, go through window
	
;status=2, Alice met but not rescued, refuse to go through window
	LD A,58
	CALL TypeMessage
	RET	

GoMyWindow3
	LD DE,MyBalcony1			;go outside
	LD BC,72*256+68				
	CALL GoIntoNewRoom									
	RET
	
;----------------------
PutLadder
	LD HL,ExtendLadderStatus
	LD A,(HL)
	OR A
	RET NZ							;ladder already put

	LD A,(ChosenItem)
	CP 30							;ladder?
	JP NZ,ItemEvents	
;put down ladder
	INC (HL)						;change ladder status	
	CALL KillItemHeld
	CALL IncreaseScore
	LD A,57
	CALL TypeMessage
	RET
	
		
;----------------------
QuenchMyFire
;check if trashcan held
	LD A,(ChosenItem)
	CP 1
	JP NZ,ItemEvents				;if not, go to pick/drop item
;check if trashcan filled with water
	LD A,(TrashcanStatus)
	CP 2; 							2=filled
	JP NZ,ItemEvents		
;change flames status
	LD HL,MyFlamesStatus
	INC (HL)
;comment 
	LD A,3	
	CALL TypeMessage			
	CALL KillItemHeld
;score
	CALL IncreaseScore	
		
	RET		
;----------------------
TakeDeodorant
;type message when taking deodorant and move it from shelf
	LD HL,DeodorantStatus
	LD A,(HL)
	OR A
	JP NZ,ItemEvents
	INC (HL)						;change status, so don't execute this code again
	LD A,168
	LD (DeodorantL),A				;change position

	LD A,4
	CALL TypeMessage				;comment 
	RET
	
;----------------------
GetLockpick
	LD HL,LockpickStatus
	LD A,(HL)
	OR A
	RET NZ							;A>0 -> lockpick already taken
	
	LD A,(ChosenItem)
	CP 21							;is player holding an angle
	RET NZ							;no = do nothing
	
	INC (HL)						;taking = change status
	LD A,248
	LD (LockpickL),A				;change position of lockpick					
	
	LD A,29
	CALL TypeMessage				;lockipick taking message
	CALL KillItemHeld
	
	CALL IncreaseScore	
	RET

;----------------------
FindHammer
;find hammer behind Benny's bed
	LD HL,HammerStatus
	LD A,(HL)
	OR A
	JP NZ,ItemEvents				;hammer already found
	INC (HL)						;change hammer status, so don't execute this code again
	LD HL,BennyRoom
	LD (HammerRoom),HL				;change hammer room to make it appear

	LD A,5
	CALL TypeMessage
	CALL IncreaseScore
	RET

;----------------------	
TakeExtinguisher	
;test if player learnt about extinguisher
	LD HL,ExtingStatus									
	LD A,(HL)
	OR A							;A=0 type info, A<>0 use item
	JR NZ,CheckIfBreakGlass	
	
;extingusher first seen,type info
	INC (HL)						;change status,extinguisher seen
	LD A,6
	CALL TypeMessage		
	RET			
	

CheckIfBreakGlass					;check if extingusher glass already broken
	CP 1
	JP NZ, ItemEvents				;glass already broken
;check if hammer held
	LD A,(ChosenItem)
	CP 8
	JR NZ, BreakWithHands			;no hammer held
BreakGlass	
	INC (HL)						;extinguisher status=2,broken glass
	LD HL,MyCorridor3
	LD (ExtinguisherRoom),HL				;place extinguisher in current room
	
	LD A,7
	CALL TypeMessage	
	CALL KillItemHeld
	CALL IncreaseScore
	RET
	
BreakWithHands						;break glass with hands=death								
	LD A,22
	CALL TypeMessage				;comment
	CALL GameOver	
	RET
	
;----------------------
GetKeyring
	LD HL,KeyringStatus
	LD A,(HL)
	CP 1							;status=1 means that player can search the locker and find key
									;status=0 or status=2 mean don't search the locker
	JP NZ,ItemEvents				;keyring already found or player can't find it yet
	
	INC (HL)						;change keyring status, so don't execute this code again
		
	LD HL,ServantsRoom02
	LD (KeyringRoom),HL				;change keyring room to current room
	
	LD A,8
	CALL TypeMessage				;message
	CALL IncreaseScore
	RET

;----------------------
SeeGraffiti
	LD A,13
	CALL TypeMessage
	RET

;----------------------		
HideoutDoor
	LD HL,HideoutDoorStatus
	LD A,(HL)
	OR A
	JR NZ, GoIntoHideout			;door unlocked
	LD A,(ChosenItem)
	CP 9							;check if keyring held
	JP NZ,ItemEvents				;no keyring held
;opening door
	INC (HL)						;change door status to opened
	LD A,9
	CALL TypeMessage				;comment
	CALL IncreaseScore	
				
GoIntoHideout
	LD DE,MyHideout1
	LD BC,20518						;B=80,C=30,position	
	CALL GoIntoNewRoom					
	RET
	
;----------------------		
GoInnerHideout
	LD HL,BoxesStatus
	LD A,(HL)
	OR A
	JR NZ,GoInnerHideout2
	
;see boxes for the first time
	INC (HL)						;status=1, boxes seen	
	LD A,44
	CALL TypeMessage
	RET

GoInnerHideout2
	CP 1
	JR NZ,GoInnerHideout3			;status=2 - boxes removed, go through door
	
	LD A,(ChosenItem)
	CP 27							;steride pill?
	RET NZ							;if not, do nothing

;move boxes	
	INC (HL)						;change status to 2
	LD A,45
	CALL TypeMessage				;message about boxes moving
	CALL KillItemHeld
	CALL IncreaseScore
	RET
	
GoInnerHideout3
;go into next room	
	LD DE,MyHideout2
	LD BC,80*256+44
	CALL GoIntoNewRoom	
	RET


;----------------------
GoBennyRoom
	LD HL,BennyDoorStatus
	LD A,(HL)
	OR A
	JR NZ,GoBennyDoor2	
	
;trying to go through door for the first time	
	INC (HL)					;don't display describtion in future
	LD A,16 					
	CALL TypeMessage			;type door describtion
	RET
GoBennyDoor2
	CP 1						;need to push key out of lock
	JR Z,PushBennyKey
	CP 2						;need to collect key with magnet
	JR Z,CollectBennyKey
	
GoBennyDoor3					;if door opened, go through it
	LD DE,BennyRoom
	LD BC,20517					;B=80,C=35,position	
	CALL GoIntoNewRoom					
	RET
	
PushBennyKey
	LD A,(ChosenItem)
	CP 16						;screwdriver
	JP NZ,ItemEvents			;no screwdriver held
	INC (HL)					;change door status, key pushed out		
	LD A,17
	CALL TypeMessage 			;message
	CALL IncreaseScore
	RET
	
CollectBennyKey
	LD A,(ChosenItem)
	CP 17 						;magnet
	JP NZ,ItemEvents			;no magnet held
	INC (HL)					;change door status, door opened
	LD A,18
	CALL TypeMessage 			;collect key message
	CALL KillItemHeld
	CALL IncreaseScore	
	JR GoBennyDoor3


;----------------------
GetAngle
	LD HL,AngleStatus
	LD A,(HL)
	OR A
	JP NZ,ItemEvents			;status<>0 -> angle already taken
;get angle
	INC (HL)					;change status
	LD HL,AngleH
	LD A,80
	LD (HL),A
	INC HL
	LD A,149
	LD (HL),A					;new angle position
	
	LD A,56
	CALL TypeMessage
	RET
						
;----------------------
OpenWardrobe
	LD HL,WardrobeStatus
	LD A,(HL)
	OR A						;0 = wardrobe closed
	JP NZ, ItemEvents			;wardrobe open, do nothing		
		
	LD A,(ChosenItem)
	CP 9						;check if keys held	
	RET NZ						;no keys, do nothing

;open wardrobe and find amulet
	INC (HL)					;change wardrobe status
	LD HL,MyHideout2
	LD (AmuletRoom),HL			;change amulet room
		
	LD A,10
	CALL TypeMessage			;message
	CALL KillItemHeld	

	CALL IncreaseScore
	RET

;----------------------
FindLipstick
	LD HL,LipstickStatus
	LD A,(HL)
	OR A
	JR NZ,FindLipstick2			;lipstick already taken

;taking lipstick	
	INC (HL)					;change lipstick status
	LD HL,AliceToilet
	LD (LipstickRoom),HL
	
FindLipstick2
	LD A,12
	CALL TypeMessage
	RET
	
;----------------------
GetLighter
;take lighter with mop
	
	LD A,(ChosenItem)
	CP 3 						;mop
	JP NZ,ItemEvents
		
	LD HL,AliceAbanRoom
	LD (LighterRoom),HL			;change lighter room
	
	LD A,23
	CALL TypeMessage
	CALL IncreaseScore
	CALL KillItemHeld			;destroy mop
	RET
	
;----------------------
SeeOldLift
	LD HL,OldLiftStatus
	LD A,(HL)
	OR A
	JR NZ,SeeOldLift2			;lift already seen
	INC (HL)
	LD A,24
	CALL TypeMessage			;message - see lift for first time
	RET
	
SeeOldLift2
	LD A,(ChosenItem)
	CP 15						;lighter needed to see in a dark lift
	JP NZ,ItemEvents			;no lighter held
	
	LD A,(HL)
	CP 1						;lift status - only 1 = gloves not found yet
	JP NZ,ItemEvents
	INC (HL)					;change status to 2 - gloves found
	
	LD HL,InactiveLift
	LD (GlovesRoom),HL			;change gloves room
		
	LD A,25
	CALL TypeMessage			;find gloves message
	CALL IncreaseScore
	RET
				
;----------------------		
QuenchAliceFire
	LD A,(ChosenItem)
	CP 13						;check if extinguisher held
	JP NZ,ItemEvents			;if not, go to pick/drop item
	
	LD HL,AliceFireStatus
	INC (HL)					;change flames status
 
	LD A,3	
	CALL TypeMessage			;quench fire comment
	CALL KillItemHeld			;destroy extinguisher

	
	CALL IncreaseScore
	RET
	
;----------------------
GetTube
;break tube from gramophone
	LD HL,TubeStatus
	LD A,(HL)
	OR A
	JP NZ,ItemEvents 			;tube already taken
	INC (HL)					;change tube status, so don't execute this code again
	LD A,219
	LD (TubeL),A				;change tube position

	LD A,15
	CALL TypeMessage			;get tube message
	RET	
	

;---------------------
GoUpstairsAliceFloor
	LD A,27
	CALL TypeMessage
	
	LD DE,MyStaircase
	LD BC,80*256+36				
	CALL GoIntoNewRoom
	RET

;---------------------
GoUpstairsMyFloor
	LD A,27
	CALL TypeMessage
	
	LD DE,MyStaircase
	LD BC,72*256+85				
	CALL GoIntoNewRoom
	RET
	
;---------------------
GoUpstairsBennyFloor
	LD A,27
	CALL TypeMessage
	
	LD DE,JoshStaircase
	LD BC,80*256+39				
	CALL GoIntoNewRoom
	RET

;---------------------
GoDownstairsJoshFloor
	LD A,26
	CALL TypeMessage
	
	LD DE,MyStaircase
	LD BC,72*256+83				
	CALL GoIntoNewRoom
	RET

;---------------------
GoDownstairsBennyFloor
	LD A,26
	CALL TypeMessage
	
	LD DE,MyStaircase
	LD BC,80*256+38				
	CALL GoIntoNewRoom
	RET

;---------------------
GoDownstairsMyFloor
	LD A,26
	CALL TypeMessage
	
	LD DE,AliceStaircase
	LD BC,72*256+85				
	CALL GoIntoNewRoom
	RET
	
;---------------------
GoStaircaseDoor
	LD HL,StaircaseDoorStatus
	LD A,(HL)
	OR A					;A=0 - player tries to go through the door for the first time
	JR NZ,GoStaircaseDoor2
	
	INC (HL)				;change status - door already visited
	LD A,30
	CALL TypeMessage		;message about locked door
	RET
	
GoStaircaseDoor2
	CP 1
	JR NZ,GoStaircaseDoor3	;A>1 - door opened, go through it
	
	LD A,(ChosenItem)
	CP 23					;does player have lockpick
	RET NZ					;do nothing is he hasn't
	
	INC (HL)				;opening door, change status
	LD A,31
	CALL TypeMessage		;message about opening the door
	CALL KillItemHeld
	CALL IncreaseScore
	
GoStaircaseDoor3
	LD DE,AliceCorridor1	;going through door
	LD BC,80*256+39
	CALL GoIntoNewRoom
	RET	

;---------------------
PryBrick
	LD HL,PryBrickStatus
	LD A,(HL)
	OR A
	JR NZ,PryBrick2
	
;see brick for the first time
	INC (HL)			;change status to 1
	LD A,32
	CALL TypeMessage		;message about seeing a brick
	RET

	
PryBrick2
	CP 2
	JP Z,ItemEvents			;brick already removed
	
	LD A,(ChosenItem)
	CP 22					;player holding crowbar?
	JP NZ,ItemEvents		;if not do nothing
	
;prying brick	
	INC (HL)				;increase brick status
	
	LD HL,JoshCorridor1
	LD (HeavyBrickRoom),HL	;brick appears
	LD (ModulatorRoom),HL	;modulator appears
	
	LD A,65
	CALL TypeMessage		;message about inding a device
	CALL IncreaseScore
	RET
	
;---------------------
LoseExtinguisher
	LD A,(ChosenItem)
	CP 13;					;holding extinguisher?
	JP NZ,ItemEvents		;if not,do nothing
	
	
	LD A,33					;using and losing extinguisher
	CALL TypeMessage		;message
	CALL KillItemHeld		;item lost
	RET
	
	
;---------------------
ThrowRope
	LD HL,RopeStatus
	LD A,(HL)				;is rope already hanging?
	OR A
	JR NZ,ThrowRope2		;if so, climb up	

	
	LD A,(ChosenItem)
	CP 25					;is player holding rope?
	JP NZ,ItemEvents		;if not,do nothing
	
	INC (HL)				;change rope status
	LD A,35
	CALL TypeMessage		;message about rope throwing
	CALL KillItemHeld
	CALL IncreaseScore
	RET
	
ThrowRope2
	LD DE,MansionEntrance	;rope is hanging, climb up
	LD BC,80*256+44
	CALL GoIntoNewRoom
	RET						

;---------------------
GoMansionDoor
	LD HL,MansionDoorStatus
	LD A,(HL)
	OR A					;are doors opened?	
	JR NZ,GoMansionDoor2	;if yes, go through door

	LD A,(ChosenItem)		;player holding crowbar?
	CP 22
	JP NZ,ItemEvents		;no crowbar, do nothing
	
	INC (HL)				;opening door, change status
	LD A,34					;message about opening door
	CALL TypeMessage
	CALL KillItemHeld
	CALL IncreaseScore
	RET
	
GoMansionDoor2
	LD DE,Reception			;going through door
	LD BC,80*256+39
	CALL GoIntoNewRoom
	RET
	
;---------------------
FixWire
	LD HL,BadWireStatus
	LD A,(HL)
	CP 2					;is wire repaired?
	RET Z					;if so do nothing
	
	OR A
	JR NZ,FixWire2

;status=0 - wire first seen
	INC (HL)				;change status
	LD A,36										
	CALL TypeMessage		;see wire message
	RET

FixWire2
	LD A,(ChosenItem)
	CP 11					;player holding gloves?
	RET Z					;let him live, but do nothing if yes
	
	CP 26					;player holding wire?
	JR NZ,FixWire4			;if not, die

;player holding wire, check if is second item are gloves
	LD HL,Item1Held			;find second item
	LD A,(SelectedItem)
	OR A
	JR NZ,FixWire3
	INC HL
FixWire3
	LD A,(HL)				;second item found
	CP 11					;it it gloves?
	JR NZ,FixWire4			;if not, die
		
;repair cable
	LD A,38
	CALL TypeMessage
	LD A,2
	LD (BadWireStatus),A	;wire repaired
	DEC A
	LD (ComputerStatus),A	;computer working now
	CALL KillItemHeld
	CALL IncreaseScore
	RET
	
FixWire4
	LD A,37					
	CALL TypeMessage
	JP GameOver
	
	
;---------------------
SeeJosh
	LD HL,JoshStatus
	LD A,(HL)
	OR A
	RET NZ;					;a<>0 means Josh already seen
	INC (HL)				;change Josh status
	LD A,39					
	CALL TypeMessage
	RET
	
;---------------------
OpenSafe
	LD HL,SafeStatus
	LD A,(HL)
	OR A
	JR NZ,OpenSafe1
	
;safe seen for the first time
	INC (HL)			;change status	
	LD A,40					
	CALL TypeMessage	;safe locked message
	RET

OpenSafe1
	CP 1
	JR NZ,OpenSafe2
	
;status =1,check putting newspaper below safe
	LD A,(ChosenItem)
	CP 7				;newspaper?
	RET NZ				;not newspaper, do nothing
	
	INC (HL)			;change status
	LD A,41					
	CALL TypeMessage
	CALL KillItemHeld	
	RET

OpenSafe2
	CP 2
	JR NZ,OpenSafe3

;status =2,check setting fire with lighter
	LD A,(ChosenItem)
	CP 15				;lighter?
	RET NZ				;not lighter, do nothing
	
	INC (HL)			;change status
	LD A,42					
	CALL TypeMessage
	RET
	
	
OpenSafe3
	CP 3
	JP NZ,ItemEvents	;status<>3 means status=4, safe opened=do nothing
	
;status=3,check throwing deodorant
	LD A,(ChosenItem)
	CP 2				;deodorant?
	RET NZ				;not deodorant, do nothing
	
	INC (HL)			;change status
	
	LD HL,JoshToilet	;after destroying safe items appear
	LD (CrowbarRoom),HL
	LD (PillRoom),HL
	
	LD A,43					
	CALL TypeMessage	;throw deodorant message
	CALL KillItemHeld
	
	CALL IncreaseScore
	RET
	
;---------------------
GetJetpack
	LD HL,JetpackStatus
	LD A,(HL)
	OR A
	JP NZ,ItemEvents	;status<>0 - jetpack already taken
;taking jetpack
	INC (HL)			;status=1
	LD A,202
	LD (JetpackL),A		;change jetpack position

	LD A,46				;message
	CALL TypeMessage
	RET
	
;---------------------
OpenSanctumDoor
	LD HL,SanctumDoorStatus
	LD A,(HL)
	OR A
	JR NZ,OpenSanctumDoor1

;see door for the first time	
	INC (HL)			;change door status, don't display message again
	
	LD A,3				;after seeing a door, a new email arrives at Josh computer
	LD (ComputerStatus),A

	LD A,47
	CALL TypeMessage	;message about locked door
	
OpenSanctumDoor1
	CP 3
	JR Z,GoSanctumDoor
	CP 2				;status=2 - player read an email
	JP NZ,ItemEvents	;if no, do nothing
	
	LD A,(ChosenItem)
	CP 12				;lipstick?
	JP NZ,ItemEvents	;if not, do nothing

;opening door
	INC (HL)			;now status=3
	LD A,48
	CALL TypeMessage
	CALL KillItemHeld
	CALL IncreaseScore
	CALL FlashBorder

GoSanctumDoor
	LD DE,Sanctum			;going through door
	LD BC,80*256+39
	CALL GoIntoNewRoom
	
	RET
	
;---------------------
UseAltar
	LD HL,AltarStatus
	LD A,(HL)
	OR A
	JR NZ,UseAltar2	
	
;status=0
	LD A,(ChosenItem)
	CP 20				;wine?
	JR NZ,UseAltar1
;pour wine
	INC (HL)			;change altar status
	LD A,49				;pour wine message
	CALL TypeMessage
	CALL KillItemHeld
	CALL IncreaseScore
	RET
;try to put amulet on altar without wine
UseAltar1	
	CP 6				;amulet?
	JP NZ,ItemEvents
	LD A,50				;put amulet message
	CALL TypeMessage
	LD A,51				;nothing happened message
	CALL TypeMessage
	RET

UseAltar2
	CP 1
	JR NZ,UseAltar3
;status=1,try to drop amulet
	LD A,(ChosenItem)
	CP 6				;amulet?
	JP NZ,ItemEvents	;if not, do nothing
;putting amulet on altar
	INC (HL)			;change altar status
	CALL KillItemHeld
	LD HL,Sanctum		;place amulet in this room
	LD (AmuletRoom),HL
	LD A,51
	LD (AmuletL),A
	LD A,50				;put amulet message
	CALL TypeMessage
	CALL FlashBorder
	RET
	
UseAltar3
	CP 2				;check altar status
	JP NZ,ItemEvents	;status>2 = do nothing	

;status=2, pick up charged amulet
	INC (HL)			;change altar status to 3
	LD A,180
	LD (AmuletL),A		;change amulet position
	LD A,52
	CALL TypeMessage	;take amulet message
	CALL IncreaseScore
	RET
;-------
FlashBorder
	;blinking border animation
	LD B,255
AnimAltar1
	HALT
	LD A,R
	BIT 0,A	
	LD A,0				;not XOR A to save zero flag
	JR Z,AnimAltar2
	LD A,23
AnimAltar2	
	OUT (254),A
	DJNZ AnimAltar1
	XOR A				;restore black border
	OUT (254),A
	RET

;---------------------
GetDart
	LD HL,DartStatus
	LD A,(HL)
	CP 1				;dart can be picked up only if status = 1
	JP NZ,ItemEvents
	
	INC (HL)			;change dart status
	LD A,218
	LD (DartL),A		;change dart position so it can be picked
	LD A,14
	CALL TypeMessage
	RET
	
	
;---------------------
GetLadder
	LD HL,LadderStatus
	LD A,(HL)
	OR A
	JP NZ,ItemEvents
	
;taking ladder
	INC (HL)			;change status, don't display this message again	
	LD A,152
	LD (LadderL),A
	LD A,53
	CALL TypeMessage	;take ladder message
	RET

;---------------------
KillZombie1
	LD HL,Zombie1Status
	LD A,(HL)
	OR A
	JP NZ,ItemEvents	;zombie doesn't exist -> drop items
	
	LD A,(ChosenItem)
	CP 5				;gun?
	RET NZ				;no gun -> do nothing, don't drop items (walking zombie will clear them)
	
;kill zombie	
	INC (HL)			;change zombie status
	LD A,54
	CALL TypeMessage
	CALL IncreaseScore
	RET	
	
;---------------------
KillZombie2
	LD A,(Zombie2Status)
	OR A
	RET NZ				;zombie 2 doesn't exist
	LD A,(ChosenItem)

	CP 5				;gun?
	JR Z,KillZombie2Fail
	CP 6				;amulet?
	JR Z,KillZombie2Success
	RET

KillZombie2Fail
	LD A,59
	CALL TypeMessage
	CALL DisplayZombie
	LD A,60
	CALL TypeMessage
	CALL DisplayZombie
	LD A,61
	CALL TypeMessage
	CALL GameOver
	RET
	
KillZombie2Success
	LD A,(AltarStatus)
	CP 3				;is amulet loaded
	RET NZ				;if not, do nothing

;kill zombie	
	LD A,62
	CALL TypeMessage
	CALL DisplayZombie
	LD A,63
	CALL TypeMessage
	CALL DisplayZombie
	
	LD A,1				;change zombie 2 status
	LD (Zombie2Status),A
	CALL IncreaseScore
	
	LD A,64
	CALL TypeMessage
	RET

					
;-----non specific routines------
;----------------------			
WaitForPressFire
	CALL GetPlayerInput
	BIT 4,A
	JR Z,WaitForPressFire		
	CALL SoundA
	RET

;----------------------	
WaitForPressFireNoSound
	CALL GetPlayerInput
	BIT 4,A
	JR Z,WaitForPressFireNoSound
	RET
	
;----------------------	
IncreaseScore
;B = points to increase score 
	;count new score
	LD HL,GameScore
	LD A,(HL)
	ADD A,3
	LD (HL),A

;draw new score bar
	LD HL, 16473		;score bar screen position
	CALL DrawBar
	RET
	
;----------------------	
Wait2Seconds
	LD B,100
Wait2Seconds2
	HALT
	DJNZ Wait2Seconds2
	RET	

;----------------------	
ClearScreen
	XOR A
	OUT (254),A 
	LD HL,16384
	LD (HL),A
	LD DE, 16385
	LD BC, 6911
	LDIR			
	
	RET
	
;----------------------	
ClearRoom
	  DI
	  LD (StoreSP),SP	;store stack
	  
;clear graphics 
	  LD HL,22528
      LD SP,HL
      LD H,L       
      LD B,4096/64		;(one loop is 32 x PUSH HL, it clears 64 bytes of screen1)
ClearRoom2 
	  REPT 32			;repeat 32 times
      PUSH HL
      ENDR
      DJNZ ClearRoom2 
	  
;clear attributes      
	  LD HL, 71*256+71
	  LD SP,23296
	  LD B,512/64
	  
ClearRoom3 
	  REPT 32			;repeat 32 times
      PUSH HL
      ENDR
      DJNZ ClearRoom3
	  
	  LD SP,(StoreSP)	;restore stack
	  EI	  
      RET
	

	
	
StoreSP	.WORD 0

;----------------------		
GameOver
	CALL ClearScreen
	LD HL,18566
	LD BC,GameOverData	;type game over text made of big letters (tiles)

TypeGameOver		
	LD A,(BC)
	OR A
	JR Z,GameOver2		;end of game over text
	PUSH HL
	PUSH BC
	CALL CountTileAddr 	;change tile number to tile memory address
	CALL DrawTile		;draw letter
	POP BC
	POP HL
	INC L
	INC L				;next letter position
	INC BC
	JR TypeGameOver	
			
GameOver2	
	CALL Wait2Seconds
	
	JP Start			;begin game again

	RET
GameOverData
	.BYTE 58,59,56,57,42,52,51,57,53,0


