;longer game actions like end sequence or flying jetpack

;---------ENDING-------------	
EndSequence
	CALL ClearScreen	

;draw endscreen	
	LD BC,4367					;B=17,C=15
	LD HL,16391
	CALL DrawBox	

	LD HL, 16527
	LD DE,RonEnd
	CALL DrawTile
	
	LD HL,16531
	LD DE,AliceEnd
	CALL DrawTile
		
	LD BC,8*256+1
	LD HL,18504
	LD DE,EndPic2
	CALL TileBlock			;ground below building
	
	LD HL,16527
	LD DE,EndPic3
	CALL DrawTile
	
	LD HL,16526
	LD DE,EndPic4
	LD BC,1*256+6
	CALL TileBlock
	
	LD HL,16520
	LD DE,EndPic5
	LD BC,1*256+6
	CALL TileBlock
	
	LD HL,16426
	LD DE,EndPic6
	LD BC,3*256+5
	CALL TileBlock
	
	LD BC,8*256+1
	LD HL,18504
	LD DE,EndPic2
	CALL TileBlock;ground below building
;-----------
	LD HL,20544
	LD DE,EndText1
	CALL TypeText
	CALL Wait2Seconds

		
	LD B,64

EndSequence3	
	PUSH BC
	CALL Collapse;collapse building one pixel down
	
	;change attribute to imitate fire
		;first paint all the house in blue
		;(to clear previous attributes)
	LD DE,22570
	LD BC,3*256+8
	LD A,65
	CALL AttrBlock
	POP BC
	PUSH BC
	
	;now find where the fire begins
	LD HL,22570
	LD DE,32
	LD C,9
	SRL B
	SRL B
	SRL B ;b=b/8
	
	LD A,8
	SUB B
	LD B,A;example 1: if b was 64 then after dividing it is 8 and after last operation it is 0 - n0 need to lower attribute block
		  ;example 1: if b was 48 then after dividing it is 6 and after last operation it is 2 - lower attribute block by two rows
		  
	CP 8
	JR Z,EndSequence35 ;no attribute block	needed
	INC B; make fire lower
	
	
EndSequence31
	ADD HL,DE ;go one row down
	DEC C
	DJNZ EndSequence31
	
EndSequence32
	EX DE,HL ;the fire begins lower, because the building aready collapsed a little bit
	LD B,3; now bc=dimensions of attribute block with fire

;randomly choose red or yellow fire	
	LD A,R
	AND 1
	OR A
	JR Z,EndSequence33	
	LD A,65+8*2
	JR EndSequence34	
EndSequence33	
	LD A,65+8*6

;draw fire attributes
EndSequence34	
	CALL AttrBlock
	
EndSequence35	
	POP BC
	DJNZ EndSequence3
	
	CALL EndWaitForKey
	
	LD HL,20544
	LD DE,EndText2
	CALL TypeText
	CALL EndWaitForKey
	
	LD HL,20512
	LD DE,EndText3
	CALL TypeText
	CALL EndWaitForKey
	
	LD HL,20544
	LD DE,EndText4
	CALL TypeText
	CALL EndWaitForKey
	
	CALL ClearScreen
	LD DE,EndText5
	LD HL, 72*256+136
	CALL TypeText
	CALL Wait2Seconds
	
	JP GameOver
	
;-----
EndWaitForKey
	CALL WaitForPressFireNoSound
	
	LD HL,23040
	LD BC,32*256+8
	CALL FadeOut1
	RET
	
;---------------------
Collapse
;collapse routine move  the graphics one pixel line down in described screen collumns
;it is used with building collapse or falling down with jetpack
	

;draw cloud below collapsing building
	LD A,B
	AND 2					;extract random bit
	
	LD DE,Cloud1
	OR A
	JR Z,Collapse1
	LD DE,Cloud2

Collapse1
	LD HL,18474
	CALL DrawTile

	
	HALT
	LD DE,200
	CALL SoundB1			;sound
	
;move the building one pixel line down
	LD HL,16426				;screen address of left top corner of collapsed area
	LD A,3 					;number of collumns in collapsing area
	LD C,8					;number of squares in a collapsing collumn
	
Collapse2
;you call call routine here (hl-address a-width, c-height)
	PUSH BC					;store c
	PUSH HL
	PUSH AF

	LD E,0					;clear first top line

	
Collapse3
;move one square down
	PUSH HL
	LD B,8
Collapse4	
	LD D,E					;in the first go d=0, later d=previous line
	LD E,(HL)				;store  line for moving to next line down
	LD (HL),D				;clear line in first go or fill with upper graphics later
	INC H					;go to next line
	DJNZ Collapse4
	
;go down to next square in the same collumn
	POP HL;restore H
	LD A,L
	ADD A,32
	LD L,A
	JR NC,Collapse5
	LD A,H
	ADD A,8
	LD H,A					;next screen segment if necessary

Collapse5
	DEC C					;decrease number of squares in current collumn left to do
	JR NZ,Collapse3 		;move down next square if there are still squares in the collumn left

	POP AF					;restore number of collumns
	POP HL					;restore top position 
	POP BC					;restore number of squares in the collumn
	
	INC L					;go to next collumn
	DEC A					;decrease number of collumns left to do
	JR NZ, Collapse2 
	
	RET
	
;-------------USE COMPUTER----------------------
UseComputer
	CALL ClearScreen	
	LD BC,3598
	LD HL,16393
	CALL DrawBox
	CALL DrawComputer
	
	LD A,(ComputerStatus)
	OR A
	JR NZ,UseComputer2
	
;status=0, computer out of power
	LD HL,20480
	LD DE,ComputerText1
	CALL TypeText
	JP UseComputer5	

UseComputer2
;read mail?	
	CP 2					;1st mail
	JR Z,UseComputer3
	CP 3
	JR Z,UseComputer4		;2nd mail
	
;logging into system	
	LD HL,16493	;draw Windows logo
	LD DE,CompPic1
	CALL DrawTile
	
	LD HL,20480
	LD DE,ComputerText2
	CALL TypeText

	LD A,(JoshStatus)
	CP 2					;talking about Josh with Alice?
	JR NZ,UseComputer5		;if not=don't know password, end working with computer
	
;talked about Josh=know password
	LD HL,ComputerStatus
	INC (HL)				;logged, now status=2
	LD HL,20672
	LD DE,ComputerText3		;text about logging
	CALL TypeText
	JR UseComputer5
		
	
UseComputer3
	;read 1st mail
	CALL DrawEmail
	
	LD HL,18624				
	LD DE,ComputerText4
	CALL TypeText
	
	
	CALL WaitForPressFire
	LD HL,22976
	LD BC,32*256+9
	CALL FadeOut1
	
	LD HL,18624				
	LD DE,ComputerText5
	CALL TypeText
	
	CALL WaitForPressFire
	LD HL,22976
	LD BC,32*256+9
	CALL FadeOut1
	
	LD HL,20544		
	LD DE,ComputerText6
	CALL TypeText
	
	
	LD HL,KeyringStatus		;player knows now the name WillyMcCoy
	LD A,(HL)				;and can search his locker to find keyring
	OR A					;if keyring status was 0, it is 1 now
	JR NZ,UseComputer5
	INC (HL)
	JR UseComputer5
	
UseComputer4
;read 2nd mail
	CALL DrawEmail
	LD HL,18624	
	LD DE,ComputerText7
	CALL TypeText
	
	LD A,2					;after reading this email, player can try to open sanctum door
	LD (SanctumDoorStatus),A	
	
UseComputer5
	CALL WaitForPressFire
	;CALL SoundA
	CALL DrawMenu
	CALL RefreshCurrentRoom	
	RET

;----	
DrawComputer
	;draw keyboard
	LD HL,18475
	LD DE,CompPic3
	LD BC,513
	CALL TileBlock
	LD HL,18480
	LD BC,1283
	CALL MirrorArea	
		
;draw monitor
	LD HL,16460
	LD DE,Border02
	PUSH DE
	CALL DrawTile
	LD HL,16588	
	POP DE
	CALL DrawTile	
	LD HL,16461
	LD BC,1537
	LD DE,Border03
	PUSH BC
	PUSH DE	
	CALL TileBlock
	LD HL,16589	
	POP DE
	POP BC	 
	CALL TileBlock
	LD DE,22604
	LD BC,2055;B=8,C=7
	LD A,1
	CALL AttrBlock 
	
	LD HL,16492
	LD BC,261;B=1,C=5	
	LD DE,CompPic2
	CALL TileBlock
	RET
;----	
DrawEmail
	LD DE,22637
	LD BC,6*256+5
	LD A,45
	CALL AttrBlock
	LD HL,16527
	LD DE,Email
	CALL DrawTile
	RET	
	
	
;----------BENNY------------
TalkBenny
	LD HL,BennyStatus
	LD A,(HL)
	OR A
	JR NZ,TalkBenny2
;first meet Benny  so do talking
	INC (HL)					;change benny status to 1, so no talk in future
	LD A,19
	CALL TypeMessage			;Benny sleeping message
	RET
	
TalkBenny2
	CP 1						;check if Benny woken up
	JR NZ,TalkBenny3			;if so, go to jetpack giving code
	LD A,(ChosenItem)
	CP 19						;tube
	RET NZ 						;no tube held
	INC (HL)					;change status to 2, woken up
	LD A,20
	CALL TypeMessage 			;Benny wakeup message
	CALL KillItemHeld
	CALL IncreaseScore
	RET		
	
TalkBenny3
	CP 3						;check if Benny already left
	JP Z,ItemEvents				;if so he isn't here, so pick and drop items	
	LD A,(ChosenItem)
	CP 4						;check if jetpack held
	RET NZ 						;no jetpack
	INC (HL)					;change Benny status to 3, no more Benny in room after it
	CALL KillItemHeld
	
	CALL IncreaseScore
	
;Benny leaves  wine
	LD HL,BennyRoom				;Benny leaves  wine
	LD (WineRoom),HL			;change wine room to current room
	LD A,21
	CALL TypeMessage			;type jetpack text
	
;animation of Benny flying jetpack
;draw new room
	CALL DrawBalconyRoom	
	
;Draw Benny ready to fly
	LD HL,18600
	LD DE,FlyBenny1
	CALL DrawTile

;talking
	CALL Wait2Seconds
		LD HL,16384+2048
		LD DE,FlyTalkBenny1
		CALL TypeText
	CALL Wait2Seconds
		LD HL,16384+2048+64
		LD DE,FlyTalkBenny2
		CALL TypeText
	CALL Wait2Seconds		
		
;change legs
	LD HL,20519
	LD DE,FlyBenny2
	CALL DrawTile

	LD E,220
	CALL FlyAnim
			
;flying sequence ended, go back to room
	LD DE,BennyRoom
	LD BC,20521;position	
	CALL GoIntoNewRoom					
	RET

;------------------
FlyAnim
	HALT
	HALT
	XOR A
	OUT (254),A;sound
	LD H,72
	LD L,167
	LD D,6
	
FlyAnim1
	PUSH HL	;rotate one char line,8lines
	LD C,8
		
FlyAnim2		
	LD B,25	;rotate one line
	PUSH HL
	
FlyAnim3
		RR (HL)
		INC L
		DJNZ FlyAnim3
	SCF
	CCF
	POP HL
	INC H
	DEC C
	JR NZ,FlyAnim2	
;next char line
	POP HL
	LD A,L
	ADD A,32
	LD L,A
	JR NC,FlyAnim4
	LD A,H
	ADD A,8
	LD H,A	;next screen segment
FlyAnim4			
	DEC D
	JR NZ,FlyAnim1		
	SCF
	CCF
	LD A,16
	OUT (254),A;sound
		
	DEC E
	JR NZ, FlyAnim
	RET	
	
;---------
DrawBalconyRoom
;draw new room
	LD BC,20484;position

DrawBalconyRoom2	
	LD DE,Balcony
	CALL GoIntoNewRoom
	
;draw player standing
	XOR A
	LD (Rotation),A
	INC A
	LD (Walking),A
	CALL StandInPlace
	
;draw balcony
	LD BC,1537;B=6,C=1
	LD HL,20580
	LD DE,BalconyPartInv
	CALL TileBlock
;Draw Jetpack
	LD HL,18631
	LD DE,Jetpack
	CALL DrawTile
	LD A,71
	LD (23047),A
	RET

;------------ALICE----------------
MeetAlice
	CALL DrawAlice
	CALL SoundA

	LD HL,JoshStatus
	LD A,(HL)
	CP 1
	JR Z,MeetAliceJosh			;after seeing dead Josh talk to Alice about it
	
	LD A,(ChosenItem)
	CP 4						;jetpack?
	JP Z,MeetAliceJetpack
	CP 28						;syringe
	JP Z,MeetAliceSyringe
	
	
	LD HL,AliceStatus
	LD A,(HL)
	OR A						
	JR NZ,MeetAlice2			;Alice already seen
	

MeetAlice1						;status=0 - see Alice for first time
	INC (HL)					;change Alice status to 1
	
	LD A,2
	LD (MyWindowStatus),A		;after meeting Alice don't go through window in my room
								;until you rescue Alice
	
	LD HL,20480					;talking to Alice
	LD DE,AliceTalk1
	CALL TypeText
	CALL EndWaitForKey

	LD HL,20480
	LD DE,AliceTalk2
	CALL TypeText
	CALL EndWaitForKey
	
	LD HL,20480
	LD DE,AliceTalk3
	CALL TypeText
	CALL EndWaitForKey

	LD HL,AliceBedroom
	LD (LiftCardRoom),HL		;put liftcard on floor
	
	LD HL,CallHelpActive		;end of calling for help
	INC (HL)		
			
	CALL DrawMenu
	CALL RefreshCurrentRoom	
	RET	

MeetAlice2						;Alice earlier seen
	CP 1						;test  if player checked lift (ststus=2 then) as she asked him
	JR NZ,MeetAlice3			
	
	LD HL,20480					;ask for checking lift
	LD DE,AliceTalk4 
	CALL TypeText
	CALL EndWaitForKey
	CALL DrawMenu
	CALL RefreshCurrentRoom	
	RET
	
	
MeetAlice3
	LD HL,20480
	LD DE,AliceTalk5 			;player checked lift - say about fire
	CALL TypeText
	CALL EndWaitForKey
	CALL DrawMenu
	CALL RefreshCurrentRoom	
	RET
	
MeetAliceJosh
	INC (HL)					;change Josh status to avoid talking about him again
	LD HL,20480
	LD DE,AliceTalk7 			;talk about dead Josh
	CALL TypeText
	CALL EndWaitForKey
	
	LD HL,18656
	LD DE,AliceTalk8 			
	CALL TypeText
	CALL EndWaitForKey
	
	CALL DrawMenu
	CALL RefreshCurrentRoom	
	RET


MeetAliceSyringe
	LD HL,20480
	LD DE,AliceSyringeText1
	CALL TypeText
	CALL EndWaitForKey
	
	LD HL,20480
	LD DE,AliceSyringeText2
	CALL TypeText
	CALL EndWaitForKey

	LD HL,20480
	LD DE,AliceSyringeText3
	CALL TypeText
	CALL EndWaitForKey
	
	CALL KillItemHeld
	CALL IncreaseScore
	LD A,3
	LD (AliceStatus),A			;Alice dissapears from room
	LD (MyWindowStatus),A		;you can escape through window now
	
	CALL DrawMenu
	CALL RefreshCurrentRoom	
	RET
	
;---------------	
DrawAlice
	CALL ClearScreen; 			;draw meeting picture
	LD BC,3343					;B=13,C=15
	LD HL,16393
	CALL DrawBox	
	LD HL, 16458
	LD DE,Ron1
	CALL DrawTile				;draw Ron
	LD HL,16496
	LD DE,AlicePic1				;draws Alice
	CALL DrawTile
	LD  A,126;draws top of Ron head
	LD (18221),A			
	LD A,65
	LD (22573),A
	RET	

;---------------
MeetAliceJetpack
	LD HL,20480
	LD DE,AliceTalk6 ;text about using jetpack
	CALL TypeText
	CALL EndWaitForKey

FlyAlice
;draw location	
	LD A,3
	LD (AliceStatus),A			;player carrying Alice in his arms
	
	LD BC,18600
	CALL DrawBalconyRoom2
	CALL DrawMenu
	CALL Wait2Seconds
	
	CALL JumpSpriteIntoBuffer	;change player legs
	HALT					
	LD HL,80*256+40
	LD DE,EmptySpace2
	LD BC,2*256+2
	CALL TileBlock				;clear old legs
	
	LD HL,(NewPlayerPos)			
	CALL DrawPlayer				;draw new legs
	
	LD HL,80*256+39
	LD DE,JetpackFlame
	CALL DrawTile				;draw jetpack flame
	
	LD E,112
	CALL FlyAnim				;move player right
	
	LD HL,80*256+53
	LD DE,EmptySpace2
	CALL DrawTile				;clear jetpack flame
	
;conversation
	LD HL,18432
	LD DE,AliceJetpackText1
	CALL TypeText
	CALL Wait2Seconds
	
	LD HL,18432+32
	LD DE,AliceJetpackText2
	CALL TypeText
	CALL Wait2Seconds
	
	LD HL,18432+96
	LD DE,AliceJetpackText3
	CALL TypeText
	CALL Wait2Seconds
	
	LD HL,18432+160
	LD DE,AliceJetpackText4
	CALL TypeText
	
;falling down
	LD B,88
	
FlyAlice2
	XOR A
	OUT (254),A
	HALT
	PUSH BC	
	
	LD HL,72*256+180;screen address of left top corner of collapsed area
	LD A,5 ;number of collumns
	LD C,11;number of square in a collumn
	CALL Collapse2
	POP BC
	LD A,16
	OUT (254),A
	
	DJNZ FlyAlice2
	JP GameOver
;---
JetpackFlame
	.BYTE 1,1	
	.BYTE	178,170,178,170,146, 84, 68, 56
	.BYTE	 71
	
;----------------------			
OpenCar
	LD HL,CarStatus
	LD A,(HL)
	OR A
	JR NZ,OpenCar2	

;see car for the first time	
	INC (HL)			;change car status
	LD A,66
	CALL TypeMessage
	RET

OpenCar2
	CP 2				;car already flied away?
	JP Z, ItemEvents
	
	LD A,(ChosenItem)
	CP 29				;modulator?
	JP NZ, ItemEvents
	
;meeting bad guy sequence
	LD A,67
	CALL TypeMessage	;opening car message
	CALL IncreaseScore
	
;draw bad guy	
	CALL ClearScreen
	LD BC,3343;B=13,C=15
	LD HL,16393
	CALL DrawBox	
		
;draw bad guy with pistol
	LD HL,16462
	LD DE,Ron1
	CALL DrawTile;draws Ron to obtain legs
	LD HL,16462
	LD DE,BadGuyPic1
	CALL DrawTile;draws bad guy top
	LD HL,16459
	LD DE,Moon
	CALL DrawTile;draws moon	
	LD A,65
	LD DE, 22863
	LD BC,1284
	CALL AttrBlock;color legs	
	LD A,41
	LD DE, 22954	
	LD BC,2817
	CALL AttrBlock ;color boots
	
	LD HL,16618
	LD DE,FlyCarPic
	CALL DrawTile
	CALL SoundA

;type texts	
	LD HL,20480+96
	LD DE,BadGuyText1
	CALL TypeText
	CALL EndWaitForKey

	LD HL,20480+32
	LD DE,BadGuyText2
	CALL TypeText
	CALL EndWaitForKey
	
	LD HL,20480+32
	LD DE,BadGuyText3
	CALL TypeText
	CALL EndWaitForKey
	
;check if second player's item is talisman
	LD HL,Item1Held			;find second item
	LD A,(SelectedItem)
	OR A
	JR NZ,OpenCar3
	INC HL
OpenCar3
	LD A,(HL)				;second item found
	PUSH AF					;store if player has talisman
	CP 6					;talisman?
	JR NZ,OpenCar4			;player hasn't a talisman	
	
	
	LD HL,20480+32			;texts which appear if player has talisman
	LD DE,BadGuyText4
	CALL TypeText
	CALL EndWaitForKey
	
	LD HL,20480+32
	LD DE,BadGuyText5
	CALL TypeText
	CALL EndWaitForKey
	
OpenCar4
					
	LD HL,20480+32			;bad guy shots
	LD DE,BadGuyText6
	CALL TypeText
	CALL EndWaitForKey

;bad guy shoots - animation	

	CALL DrawMenu
	CALL RefreshCurrentRoom	;restore room and menu

	
	LD HL,72*256+33			;draw bad guy
	LD DE,BadGuyPic2
	CALL DrawTile
	
	LD HL,72*256+4*32+4		;initial bullet position
	
MoveBullet
	XOR A					;draw bullet and store background
	LD C,(HL)
	LD (HL),A
	
	INC H
	LD A,126
	LD D,(HL)
	LD (HL),A
	
	INC H
	XOR A
	LD E,(HL)
	LD (HL),A
	
	LD B,10
MoveBullet2	
	XOR A
	OUT (254),A				;sound and delay
	HALT
	LD A,16
	OUT (254),A
	DJNZ MoveBullet2
	
	LD (HL),E				;restore background
	DEC H
	LD (HL),D
	DEC H
	LD (HL),C
	INC L					;move bullet
	
	LD A,(NewPlayerPos)	;get player L position
	ADD A,3*32
	INC A				;go to line of bullet
	CP L				;compare to belltet position
	JR Z,MoveBulletEnd
	JR MoveBullet
	
MoveBulletEnd
	CALL Wait2Seconds
	CALL ClearScreen
	POP AF				;restore if player has talisman
	CP 6
	JP NZ,GameOver		;if not, game over
	
	LD A,69
	CALL TypeMessage	;return consciousness text

	LD HL,CarStatus		;car dissapears
	INC (HL)
	
	LD HL,RoofTop02
	LD (DartRoom),HL	;dart appears
	
	LD HL,Item1Held		;take talisman from player's possession
	LD A,(SelectedItem)		
	OR A
	JR NZ,OpenCar5
	INC HL
OpenCar5					
	CALL KillItemHeld3	;destroy amulet ( second item in player's inventory)
	
	CALL DrawMenu
	CALL RefreshCurrentRoom	;restore room and menu
	
	LD A,1
	LD (DartStatus),A	;dart can be picked now
	RET