;-----------LIFT-------------
GoLift1
	;check if LiftCard in inventory
	LD A,(ChosenItem)
	CP 14
	JR Z,TravelLift
	
;don't have a liftcard
	LD A,11
	CALL TypeMessage	
	RET
				
TravelLift
	LD HL,AliceStatus
	LD A,(HL)
	CP 3					;if Alice status is 3 don't change it back to 2
	JR Z,TravelLift2
	LD A,2					;lift was used, so change status of conversation with Alice
	LD (HL),A		
	
TravelLift2	
;draw lift	
	LD DE,LiftShaft
	LD BC,18639				;player position
	CALL GoIntoNewRoom		;draw lift room
	
	XOR A
	LD (Rotation),A
	INC A
	LD (Walking),A
	CALL StandInPlace			;draw player in standing position
	
FloorDescribtion
	LD HL,18656	
	LD DE,FloorLiftText
	CALL TypeText
	
	LD A,(FloorNr)		;draw ceiling at floor 29	
	CP 39
	CALL Z,LiftShaftTop
	
LiftControl
	LD A,(FloorNr)		;animate flames on bottom floor 26	
	CP 36
	CALL Z,LiftShaftFlames							
								
	CALL GetPlayerInput			;get control
	LD (Joystick),A
	CP 8						;up
	JR Z,MoveLiftUp
	CP 4						;down
	JR Z,MoveLiftDown
	CP 16						;going out of lift(fire pressed)
	JR Z,	LeaveLift
	JR LiftControl
	
;--------------------
LeaveLift	
	LD A,(FloorNr)				;determine floor
	SUB 35						;FloorNr variable stores the code of a digit character (0 - code 30, 1 - code 31, ... ,6-36,7-37,8-38,9-39 )
	LD B,A						;floor 26 is the lowest floor possible in the game and character code for "6" is 36
	LD HL,LiftFloorsData-2		;so turn floor 26 into number 1, floor 27 into number 2 etc. to count address af room after leaving the lift
		
CountFloorRoom
	INC HL
	INC HL
	DJNZ CountFloorRoom
	
	LD E,(HL)
	INC HL
	LD D,(HL)					;room adrress in DE
					
	LD BC,20527					;player position
	
	CALL GoIntoNewRoom
	RET

;-------------------			
MoveLiftUp	
;the lift can move between foors 26-29
;if it tries to go higher than 29, don't allow to do it
	LD HL,FloorNr
	LD A,(HL)
	CP 39;						;39 is code for "9"
	JR Z,FloorDescribtion		;can't go up
	
	INC (HL)					;lift goes up, change floor
	JR MoveLift
	
;-------------------			
MoveLiftDown	
;the lift can move between foors 26-29
;if it tries to go lower, don't allow to do it
	LD HL,FloorNr
	LD A,(HL)
	CP 36;						;36 is code for "6"
	JR Z,FloorDescribtion		;can't go down
	
	DEC (HL)					;lift goes down, change floor
	JR MoveLift
	

;-------------------			
MoveLift
	;clear celing and flames
	CALL ClearLiftShaft

	LD B,128					;number of lines to scroll to travel to next floor
MoveLift2		
	PUSH BC	
	HALT
	XOR A
	OUT (254),A					;sound
	
	LD L,10
	CALL MoveLift3				;scroll animation - bricks left side of lift	
	LD L,19
	CALL MoveLift3				;scroll animation - bricks right side of lift	
	POP BC
	
	LD A,B
	AND 4
	SLA A
	SLA A
	OUT (254),A					;sound
	DJNZ MoveLift2
	JR FloorDescribtion			;type new floor number and go to reading keys while riding lift
	
;--------	
MoveLift3
	LD C,4						;number of character collumns to scroll
MoveLift4
	PUSH BC
	PUSH HL
	
	LD A,(Joystick)				;scroll up or scroll down?	
	PUSH AF
	CP 8	
	CALL Z, LiftCollumnUp
	POP AF				
	CP 4
	CALL Z,LiftCollumnDown	
	POP HL
	INC L						;next collumn possition
	POP BC
	DEC C						;decrease collumn number
	JR NZ, MoveLift4		
	RET		
	
;--------			
LiftCollumnUp
	;L: number of collumn scrolled
	LD H,72
		
;read most down byte and write it to the top
	PUSH HL
;count most down byte address
	LD H,87
	LD A,L
	ADD A,224
	LD L,A
				
	LD D,(HL)			;read byte content	
	POP HL				;restore address to the top

	LD B,16				;collumn is 16 characters high
LiftAnimUp1
	PUSH HL			
	
LiftAnimUp2
	LD E,(HL)			;store byte at current position
	LD (HL),D			;write byte from previous position to current
	LD D,E				; current byte becomes previous byte
	INC H				;go to new position
	
	LD E,(HL)
	LD (HL),D
	LD D,E
	INC H	
	LD E,(HL)
	LD (HL),D
	LD D,E
	INC H	
	LD E,(HL)
	LD (HL),D
	LD D,E
	INC H	
	LD E,(HL)
	LD (HL),D
	LD D,E
	INC H	
	LD E,(HL)
	LD (HL),D
	LD D,E
	INC H	
	LD E,(HL)
	LD (HL),D
	LD D,E
	INC H	
	LD E,(HL)
	LD (HL),D
	LD D,E
		
	POP HL
	LD A,L
	ADD A,32				;go to new character
	LD L,A
	JR NC,LiftAnimUp3		;no next screen segment
	LD A,H
	ADD A,8
	LD H,A					;go to next segment if necessary	

LiftAnimUp3	
	DJNZ LiftAnimUp1						
	RET					
;----------			
LiftCollumnDown
	;L: number of collumn scrolled
	LD H,72

;read most up byte and write it to the bottom
					
	LD D,(HL)				;read byte value
	
;count most down byte address
	LD H,87
	LD A,L
	ADD A,224
	LD L,A
	
	LD B,16				;collumn is 16 characters high
LiftAnimDown1
	PUSH HL			
	
LiftAnimDown2
	LD E,(HL)			;store byte at current position
	LD (HL),D			;write byte from previous position to current
	LD D,E				;current byte becomes previous byte
	DEC H				;go to new position
	LD E,(HL)
	LD (HL),D
	LD D,E
	DEC H
	LD E,(HL)
	LD (HL),D
	LD D,E
	DEC H
	LD E,(HL)
	LD (HL),D
	LD D,E
	DEC H	
	LD E,(HL)
	LD (HL),D
	LD D,E
	DEC H
	LD E,(HL)
	LD (HL),D
	LD D,E
	DEC H
	LD E,(HL)
	LD (HL),D
	LD D,E
	DEC H
	LD E,(HL)
	LD (HL),D
	LD D,E
	
	POP HL
	LD A,L
	SUB 32				;go to new character
	LD L,A
	JR NC,LiftAnimDown3	;no next screen segment
	LD A,H
	SUB 8
	LD H,A				;go to next segment if necessary	

LiftAnimDown3	
	DJNZ LiftAnimDown1					
	RET	
	
;-------------------
ClearLiftShaft	
;clear ceiling 
	LD HL,18446
	LD DE,EmptySpace
	LD BC,5*256+1
	CALL TileBlock
	
	LD HL,18448
	LD DE,Rope
	CALL DrawTile

;clear flames
	LD HL,20686
	LD DE,EmptySpace
	LD BC,5*256+2
	CALL TileBlock
	RET
	
LiftShaftTop
;draw ceiling of liftshaft (on top floor)
	LD HL,18446
	LD DE,LiftTop
	CALL DrawTile
	RET
	
LiftShaftFlames
;draw flames (on bottom floor)
	HALT
	
	LD HL,LiftFlameCycle		;change animation cycle
	INC (HL)
	LD A,(HL)
	
	LD HL,20686					;position
	LD BC,5*256+1				;size
	LD DE,LiftFlame1
	
	BIT 4,A						;determine flames frame
	JR Z,LiftShaftFlames2
	
	LD DE,LiftFlame2

LiftShaftFlames2
	CALL TileBlock
	RET

;----------	
LiftFloorsData
	.WORD AliceCorridor2
	.WORD MyCorridor2	
	.WORD BennyCorridor2
	.WORD JoshCorridor2
		
	
FloorLiftText
	.BYTE 51,15,27,6,12,15,15,18,27	;FLOOR
FloorText
	.BYTE 51,15,32					;2
FloorNr		
	.BYTE 255,27,0				  	;this byte is modified depending on which floor we are now

LiftFlameCycle						;used with animating flames at bottom floor
	.BYTE 0
	
;-------
LiftFlame1
	.BYTE 1,2
	.BYTE	  0, 32, 64, 66, 66,230,231,255
	.BYTE	254,238,108, 72,  0,  0,  0,  0
	.BYTE	 70, 86

LiftFlame2	
	.BYTE 1,2
	.BYTE	  0,  4,  2,  2, 71,103,231,255
	.BYTE	239,238,206, 68,  4,  0,  0,  0
	.BYTE	 70, 86