
;Game Variables
;they are are stored in unused parts of player sprite buffer
		
;-------------------------------
;Player control variables
;they control player movement, posessed items etc.
						
Rotation	 		.EQU 64768+192 
SpriteInSequence 	.EQU 64768+193
SpriteFrame			.EQU 64768+194

OldPlayerPos 		.EQU 64768+195
NewPlayerPos 		.EQU 64768+197

Walking				.EQU 64768+199		;0-standing, 1-walking right, 2-walking left
					  			 		;just like joystick input
Facing				.EQU 64768+200		;left or right, also used when standing
	
LeftEdgeRoom		.EQU 64768+202		;neighbour rooms
RightEdgeRoom		.EQU 64768+204
				
CurrentEvents		.EQU 64768+206		;start of events data for current room


CurrentRoom			.EQU 64768+208		;memory adress of current room data
	
PlayerEnergy		.EQU 64768+210
;Free 64768+211		

Joystick			.EQU 64768+212			;pressed keys
	
SelectedItem		.EQU 64768+213			;0 - first item selected, 1 - second item selected
		

Item1Held			.EQU 64768+214			;items held by player, 0 = no item
Item2Held			.EQU 64768+215						

ChosenItem			.EQU 64768+216			;number of active item (0 - no item)
UnchosenItem		.EQU 64768+217

InitRoomCode		.EQU 64768+218			;address of code executed after drawing room			

GameScore			.EQU 64768+220			;points obtained in game

GameCycle			.EQU 64768+221			;cycle of game 0-3 used to animate objects

GameControl			.EQU 64768+222			;player control - 0 keyboard, 1- joystick

ZombieStatus		.EQU 64768+223		;is zombie in this room?
ZombieLeftEdge		.EQU 64768+224		;left edge of zombie walk
ZombieRightEdge		.EQU 64768+225		;right edge of zombie walk
ZombieDirection		.EQU 64768+226		;walk left or walk right?
ZombiePosition		.EQU 64768+227
Zombie1Status		.EQU 64768+228		;zombie 1 alive?
Zombie2Status		.EQU 64768+229		;zombie 2 alive?

;-------------------------------		
;Action flags
;they control story of the game
FireStatus			.EQU 65024+192
FirePos				.EQU 65024+193
FireSize			.EQU 65024+194	

BatStatus			.EQU 65024+195
BatPosL				.EQU 65024+196	
BatPosH				.EQU 65024+197	
BatCycles			.EQU 65024+198
CurrentBatCycle		.EQU 65024+199
BatUpOrDown			.EQU 65024+200
		
FanStatus			.EQU 65024+201
FanH				.EQU 65024+202
FanL				.EQU 65024+203		

CallHelpRoomStatus	.EQU 65024+204		;is it a room where calling for help can be seen?
CallHelpL			.EQU 65024+205
CallHelpActive 		.EQU 65024+206		;is girl calling for help still active?
		
FrontTileStatus		.EQU 65024+207
FrontTileNr			.EQU 65024+208
FrontTileL			.EQU 65024+209				


TrashcanStatus		.EQU 65024+210
MyFlamesStatus		.EQU 65024+211
DeodorantStatus		.EQU 65024+212
HammerStatus		.EQU 65024+213
ExtingStatus		.EQU 65024+214
KeyringStatus		.EQU 65024+215
HideoutDoorStatus 	.EQU 65024+216
TubeStatus			.EQU 65024+217
WardrobeStatus		.EQU 65024+218
LiftStatus			.EQU 65024+219
OldLiftStatus		.EQU 65024+220

AliceFireStatus		.EQU 65024+221		;does fire in Alice Room exists
AliceStatus			.EQU 65024+222		;how conversation with Alice advances


BennyDoorStatus		.EQU 65024+223
BennyStatus			.EQU 65024+224

MyWindowStatus		.EQU 65024+225
LockpickStatus		.EQU 65024+226
StaircaseDoorStatus .EQU 65024+227
PryBrickStatus		.EQU 65024+228
RopeStatus			.EQU 65024+229
MansionDoorStatus	.EQU 65024+230

BadWireStatus		.EQU 65024+231		;is damage wire still sparkling	?
BadWireRoomStatus	.EQU 65024+232		;is it a room with damaged wire?

ComputerStatus		.EQU 65024+233
SafeStatus			.EQU 65024+234
SafeFireStatus		.EQU 65024+235
JoshStatus			.EQU 65024+236

BoxesStatus			.EQU 65024+237
JetpackStatus		.EQU 65024+238
SanctumDoorStatus	.EQU 65024+239
AltarStatus			.EQU 65024+240
TalismanStatus		.EQU 65024+241
LadderStatus		.EQU 65024+242
AcidStatus			.EQU 65024+243

AngleStatus			.EQU 65024+244
ExtendLadderStatus	.EQU 65024+245
LipstickStatus		.EQU 65024+246
CarStatus			.EQU 65024+247
BootsPoolStatus		.EQU 65024+248
DartStatus			.EQU 65024+249






;background,mask and sprite buffers:
	;when going to next data byte in buffer it is enough to do INC E, instead of INC DE
	;it is also easy to go from one buffer to another, just INC D,when DE contains bufffer address
	
BackgroundBuffer EQU 64768	;H=253,L=0
				 	    	;these 256 bytes  store background behind player  (192 bytes)
							;remaining 63 bytes are used to store various game variables
				
MaskBuffer	     EQU 65024  ;H=254,L=0
							;BackgroundBuffer+256
							;these 256 bytes store player mask (192 bytes)
							;remaining 63 bytes are used to store various game variables
	
SpriteBuffer     EQU 65280	;H=255,L=0
							;these 256 bytes store player sprite (192 bytes)
							;remaining 64 bytes are used for game stack
			
	

		
