;this routine is caled after pressing FIRE
;it was checked before if player can perform some actions or use some objects at his currnt location
;if actions aren't possible he will try to take/drop items

;if finds an object he'll pick it up
;if he finds an item while holding another one he'll pick new object and drop old item
;if he doesn't find a new item he'll only drop an old one or do nothing
TakeItem
;check if player is standing close to item
	LD HL,CurrentRoomItemTable			;start of current room item table
		
;compare positions				
ComparePlayerToItem	
	INC HL 								;skip item number and go to item position
	LD E,(HL)
	INC HL
	LD D,(HL)							;DE loaded with item position
		
	LD BC,(OldPlayerPos)				;BC loaded with player position
	LD A,B
	CP D
	JR NZ,NotCloseToItem
	LD A,C
	CP E								;compare BC to DE
	JR NZ,NotCloseToItem
	

	JR CloseToItem						;player close  to item confirmed
			
NotCloseToItem
	INC HL;								go to next item in current room item list
	LD A,(HL)
	OR A								;0=no more items in current room
	JR Z, EndOfRoomItems
	 		
	JR ComparePlayerToItem

EndOfRoomItems
	XOR A								;set A=0 that means that no item was picked (used by DropItem routine)	
	RET 								;no more items in this room to take, go to 	DropItem routine	
		
;-------------------------
CloseToItem	
;player is standing close to item
;there are 2 possibilities
			;1. player doesn't have selected item - just pick new item
			;2. player has selected item - pick up new item and drop old item
	
;check if 1st or 2nd item in player's inventory is selected
	LD DE,Item1Held
	LD A,(SelectedItem)					;0 = 1st item selected, 1 = 2nd item selected
	OR A
	JR Z,CloseToItem2;
	INC DE								;DE  is an address which stores the number of selected item		
CloseToItem2
	LD A,(DE)							;A loaded with number of selected item ,or A=0  if no item in inventory
	OR A								;check if item held
	PUSH AF
	CALL Z,JustPickItem					;no item in inventory, only pick new item
	POP AF	
	CALL NZ,DropOldPickNew				;exchange items
	LD A,1								;set A=1 that means that no item was picked (used by DropItem routine)
	RET 			

;-------------------------
JustPickItem
	CALL TakeItem2 						;pick item
	CALL SoundB
	CALL RefreshCurrentRoom				;draw room again, now without picked item
	CALL ItemDescribtions				;update item describtions
	RET		
		
;-------------------------
DropOldPickNew
	PUSH AF								;store number of kept item
	PUSH DE								;store which item is chosen, 1st or 2nd
	CALL TakeItem2						;picking up item,new item replaces old item
	POP DE								;restore which item is chosen
	LD A,(DE)
	LD B,A								;store picked item in B
	POP AF								
	LD (DE),A							;restore old item in iventory
	
	PUSH BC								;store picked item
	PUSH DE								;store chosen item 
	CALL DropItem						;drop old item and refresh room
	POP DE
	POP BC
	
	LD A,B
	LD (DE),A							;new item  placed again in inventory
	LD (ChosenItem),A
	CALL ItemDescribtions				;update item describtions
	RET										
			
;-------------------------
TakeItem2		
;using item number find memory address where item data begin
	DEC HL;
	DEC HL								;set HL to item number address
	LD A,(HL)
	LD (ChosenItem),A					;store item number
		
	PUSH AF								;store item number
	LD HL,GameItemData-8				;find item data address
	LD B,A
	LD DE,8 							;one item data take 8 bytes
	
FindItemData
	ADD HL,DE							;go to next item	
	DJNZ FindItemData					;repeat until item nr N is reached (address placed in HL)
			
;Delete item from room inventory
;HL points to an address of the room where the item is stored
;to delete item from current room, let's change the room address to unexisting address
;ser item room address to 257(0000000100000001B),there is no room which begins with such address
	LD A,1
	LD (HL),A
	INC HL	
	LD (HL),A		
		
;store item in player inventory
	LD A,(SelectedItem)
	OR A				;1st or 2nd item chosen
	JR NZ, TakeItemNr2
	
TakeItemNr1
	POP AF
	LD (Item1Held),A;
	RET
TakeItemNr2
	POP AF				;restore item number
	LD (Item2Held),A	;and store it  player's inventory	
	RET					;item picking is finished

		
;-------------------------		
DropItem
		
;check if 1st or 2nd item in player's inventory is selected
	LD HL,Item1Held-1
	LD A,(SelectedItem)
	OR A
	JR Z,DropItem2		;1st item selected, do only one INC HL to point to 1st item	
	
	INC HL				;do INC HL twice to point to 2nd item
DropItem2
	INC HL 
				
	LD A,(HL)			;store dropped item number into A
	OR A				;check if any item was held at all, if not just return
	RET Z				;no item = return to keyboard scanning routine
	
	LD B,A				;store dropped item number into B
	XOR A
	LD (HL),A			;set item in inventory to 0 = no item in inventory
	LD (ChosenItem),A;  ;set chosen item number to 0 too
	
	LD HL,GameItemData-8	;using item number find its data address
	LD DE,8 			;one item data take 8 bytes
DropItem3
	ADD HL,DE			;go to next item	
	DJNZ DropItem3		; repeat until item nr N is reached	and its address placed in HL	
		
;place dropped item in current room(change item data appropriately)		
	LD DE,(CurrentRoom)					
	LD (HL),E
	INC HL
	LD (HL),D			;write current room address to dropped item data
		
;using player position count item screen position and write it to item data
;item H position= player H position
;item V position = player V position + player height - item height
	
	LD DE,(OldPlayerPos)
				
;read item height
	INC HL
	INC HL
	INC HL				;HL point to address storing item tile data adress
	LD C,(HL)	
	INC HL
	LD B,(HL)			;BC loaded with item tile address
	INC BC				;first byte in tile data is tile width, go to the second - tile height
	LD A,(BC)
	LD B,A				;item height (in characters) loaded into B	
	
;count item screen position	
	LD A,6				;player height loaded into A	
	SUB B				;subtract item height
	LD B,A; 			;store result in B for a loop
	
	LD A,E				;player vertical position into A
DropItem4
	ADD A,32				
	DJNZ DropItem4
	
	LD E,A
	JR NC,DropItem5
	LD A,D				;next screen segment if necessary
	ADD A,8
	LD D,A

DropItem5
;DE contains item screen position now
	
	DEC HL				;set HL to item position data
	DEC HL
	DEC HL				

	LD (HL),D			;load new item position to item data
	INC HL
	LD (HL),E	

	CALL SoundB					;restore room with dropped item
	CALL RefreshCurrentRoom		
	CALL ItemDescribtions		;update item describtions	
	RET		
	
;-----------------------
DrawItems
;this routine draws items on screen when player entered a new room
;it also creates table of items positions
;when player presses FIRE, he tries to pick up an item and his position is compared with item positions from the table
;to create the table, a loop goes through all items in the game comparing their room with current room
	
	LD A,1
	LD (CurrentItemNr),A		;local variable, storing item number, when going through all items in the game
								;start with item nr 1

;IX contains start of table with data about items in current room	
;the table structure is:
	;number of item: 1 byte
	;position where player should stand to pick up item: 2 bytes	
	
;clear item data table;
	XOR A
	LD B,30						;3*10=10 items (table size)
	LD HL,CurrentRoomItemTable			
DrawItems2
	LD (HL),A
	INC HL
	DJNZ DrawItems2		
		
	LD IX,CurrentRoomItemTable
	LD HL,GameItemData	
			
;-----------------------	
DrawOneItem
	LD A,(HL)					;check if end of item list	
	OR A						;0 = end of list
	RET Z						;no more items
					
;check if item pointed by HL is in current room
	LD C,(HL)
	INC HL
	LD B,(HL)					;BC loaded with item room address
	INC HL
	LD DE,(CurrentRoom)

;does item room = current room (BC = DE )?	
	LD A,B;						B compare to D, C compare to E, any difference=different rooms, don't draw item
	CP D
	JR NZ,NextItem
	LD A,C
	CP E		
	JR NZ,NextItem
		
;item is in current room, draw item
	LD B,(HL)
	INC HL
	LD C,(HL)					;BC loaded with item position
	PUSH BC						;store item position
	
	INC HL
	LD E,(HL)
	INC HL
	LD D,(HL)					;DE loaded with item tile address
	
	INC DE
	LD A,(DE)
	LD (ItemHeight),A			;store item height to be used later
	DEC DE	

;draw item			
	PUSH HL						;store item address in item list
	LD H,B
	LD L,C 						;HL loaded with item screen position			
	
	CALL DrawTile				;draw item

	POP HL						;restore item list address

	
;Count and store in memory where player should be standing to be able to collect just drawn item
;item collecting H position = player H position
;item collecting V position (address of player sprite left upper corner ) = item V position + item height - player height 
;																		  = item V position - (player height - item height)
		
	POP BC						;restore item position
	PUSH HL						;store item address in item list
	LD H,B
	LD L,C						;load item position to HL

	LD A,(ItemHeight)			;count: player height-item height
	LD B,A
	LD A,6						;player height
	SUB B
	LD B,A						;(player height-item height) placed in B  	
	
	LD A,L
ItemCollectingPosition
	SUB 32						;go B character lines up
	DJNZ ItemCollectingPosition
	LD L,A
	JR NC,ItemCollectingPosition2
	
	LD A,H
	SUB 8						;change screen segment if necessary
	LD H,A;
		
ItemCollectingPosition2	
;Store item data in current room item table	
		
	LD (IX+1),L					;take item collecting position and load it to curent room item table 
	LD (IX+2),H

	LD HL,CurrentItemNr			;load to current room item table item number
	LD A,(HL)
	LD (IX+0),A	

	INC (HL)					;increase item number				
		
;Change IX to point to another item in current room item table 
	INC IX
	INC IX
	INC IX
		
;drawing of this item  is finished, but there may be other items,so repeat the routine	
	POP HL						;restore game item list address	
	INC HL
	INC HL	
	INC HL						;skip bytes with item name address and go to next item
	JR DrawOneItem
	
;-----------------------		
NextItem
;go to next item, if current item isn't present in current room
	PUSH HL
	LD HL,CurrentItemNr	
	INC (HL)					;increase item number	
	POP HL	
	LD DE,6						;go to next item data
	ADD HL,DE
	JR DrawOneItem

;local variables used by item drawing routine				
ItemHeight 		.BYTE 0
CurrentItemNr 	.BYTE 0			



;-----------------------
ChangeSelectedItem
	CALL SoundA					;play swap sound
	
;turn 0->1 and 1->0	
	LD HL,SelectedItem
	LD A,(HL)					;check which item is currently selected
	OR A						;
	JR Z, ChangeSelectedItem2

	DEC (HL)					;selected item=0
	DEC (HL)					;selected item=-1

ChangeSelectedItem2
	INC (HL)					;selected item=0 or selected item=1
	CALL ColorizeDescribtions	;change attribute selection on screen

;swap ChosenItem and UnchosenItem variables
	LD HL,ChosenItem
	LD A,(HL)
	LD B,A
	INC HL					;go to unchosen item variable
	LD A,(HL)
	LD C,A
	LD A,B
	LD (HL),A
	DEC HL					;go to chosen item variable
	LD A,C
	LD (HL),A				;chosen and unchosen items swapped			
	RET 					;return to keyboard reading routine	
	
				
;------------------------------	
KillItemHeld
;make item disappear from inventory after using it
	LD HL,Item1Held
	LD A,(SelectedItem)		;A=0 or A=1
	OR A
	JR NZ,KillItemHeld2	

KillItemHeld1
	DEC HL					;set to item 1
KillItemHeld2
	INC HL					;set to item 2

KillItemHeld3					
	XOR A
	LD (HL),A				;write 0 to inventory = erase item
	LD (ChosenItem),A
	CALL ItemDescribtions	;type new item describtions		
	RET

;------------------------------	
ItemCheat
;cheat that enables to change with arrow keys  item in inventory to any other item
	HALT
	HALT
	HALT
	HALT
	
	LD A,1
	OUT (254),A 			;border
	
	CALL GetPlayerInput

	BIT 2,A
	JR NZ,ItemCheatDown		;decrease item number

	BIT 3,A
	JR NZ,ItemCheatUp		;increase item number
	
	BIT 1,A
	JR NZ,ItemCheatEnd		;cheat end
	
	JR ItemCheat

ItemCheatDown
	LD HL, Item1Held
	LD A,(HL)
	OR A
	JR Z,ItemCheat
	DEC (HL)				;change item
	CALL ItemDescribtions	;type item
	JR ItemCheat

ItemCheatUp
	LD HL, Item1Held
	LD A,(HL)
	CP 31
	JR Z,ItemCheat
	INC (HL)				;change item
	CALL ItemDescribtions	;type item
	JR ItemCheat
	
ItemCheatEnd
	XOR A
	OUT (254),A
	RET	
;------------------------------	
InitialiseItems	
;copy items names and initial positions to game item data
;this routine is called at the start of the game and after every game over
	LD HL,InitialItemData
	LD DE,GameItemData
	LD BC,31*8				;number of items*8
	LDIR
	RET			

	

;------------------------------	
GameItemData
;data of objects positions in the game are stored here
;they are copied from initial items data every time, the game is begun
;comments show item number, byte shift from GameItem data address and item name

	.BYTE 0,0,0,0,0,0,0,0	;1		0			Trashcan
	.BYTE 0,0,0,0,0,0,0,0	;2		8			Deodorant
	.BYTE 0,0,0,0,0,0,0,0	;3		16			Mop
	.BYTE 0,0,0,0,0,0,0,0	;4		24			Jetpack
	.BYTE 0,0,0,0,0,0,0,0	;5		32			Thompson gun
	.BYTE 0,0,0,0,0,0,0,0	;6		40			Amulet
	.BYTE 0,0,0,0,0,0,0,0	;7		48			Newspaper
	.BYTE 0,0,0,0,0,0,0,0	;8		56			Hammer
	.BYTE 0,0,0,0,0,0,0,0	;9		64			Keys
	.BYTE 0,0,0,0,0,0,0,0	;10		72			RubberBoots
	.BYTE 0,0,0,0,0,0,0,0	;11		80			Gloves
	.BYTE 0,0,0,0,0,0,0,0	;12		88			Lipstick
	.BYTE 0,0,0,0,0,0,0,0	;13		96			Extinguisher
	.BYTE 0,0,0,0,0,0,0,0	;14		104			LiftCard
	.BYTE 0,0,0,0,0,0,0,0	;15		112			Lighter
	.BYTE 0,0,0,0,0,0,0,0	;16		120			ScrewDriver
	.BYTE 0,0,0,0,0,0,0,0	;17		128			Magnet
	.BYTE 0,0,0,0,0,0,0,0	;18		136			Cola can
	.BYTE 0,0,0,0,0,0,0,0	;19		144			Gramophone tube
	.BYTE 0,0,0,0,0,0,0,0	;20		152			Wine
	.BYTE 0,0,0,0,0,0,0,0	;21		160			Angle
	.BYTE 0,0,0,0,0,0,0,0	;22		168			Crowbar
	.BYTE 0,0,0,0,0,0,0,0	;23		176			Lockpick
	.BYTE 0,0,0,0,0,0,0,0	;24		184			Heavy Brick
	.BYTE 0,0,0,0,0,0,0,0	;25		192			Rope
	.BYTE 0,0,0,0,0,0,0,0	;26		200			Wire	
	.BYTE 0,0,0,0,0,0,0,0	;27		208			Pill
	.BYTE 0,0,0,0,0,0,0,0	;28		216			Dart
	.BYTE 0,0,0,0,0,0,0,0	;29		224			Modulator
	.BYTE 0,0,0,0,0,0,0,0	;30		232			Extended ladder
	.BYTE 0,0,0,0,0,0,0,0	
	.BYTE 0										;end of game items
	
;for some items their rooms or positions are used by game code
;let's define some labels for them
DeodorantL				.EQU GameItemData+8+3
JetpackL				.EQU GameItemData+24+3
AmuletRoom				.EQU GameItemData+40
AmuletL					.EQU GameItemData+40+3
HammerRoom				.EQU GameItemData+56
KeyringRoom				.EQU GameItemData+64
GlovesRoom				.EQU GameItemData+80
LipstickRoom			.EQU GameItemData+88
ExtinguisherRoom		.EQU GameItemData+96
LiftCardRoom			.EQU GameItemData+104
LighterRoom				.EQU GameItemData+112
TubeL					.EQU GameItemData+144+3
WineRoom				.EQU GameItemData+152
AngleH					.EQU GameItemData+160+2
LockpickL				.EQU GameItemData+176+3
HeavyBrickRoom			.EQU GameItemData+184
CrowbarRoom				.EQU GameItemData+168
PillRoom				.EQU GameItemData+208
DartRoom				.EQU GameItemData+216
DartL					.EQU GameItemData+216+3

ModulatorRoom			.EQU GameItemData+224
LadderL					.EQU GameItemData+232+3
		
;------------------------------			
InitialItemData
;1 - Trashcan
	.WORD MyHome			;room that contains item
	.BYTE 80,162			;screen position of item
	.WORD Trashcan; 		;item tile address
	.WORD TrashcanText		;item name text address
	
;2 - Deodorant
	.WORD MyToilet
	.BYTE 80,8 				
	.WORD Deodorant
	.WORD DeodorantText
	
;3 - Mop
	.WORD JoshCorridor3
	.BYTE 80,122
	.WORD Mop
	.WORD MopText
		
;4 - Jetpack
	.WORD MansionBalcony
	.BYTE 72,105
	.WORD Jetpack
	.WORD JetpackText		
		
;5 - Thompson gun
	.WORD MyHideout1			
	.BYTE 80,207
	.WORD ThompsonGun
	.WORD ThompsonText
			
;6 -Amulet
	.WORD 257			;no room at start
	.BYTE 80,180
	.WORD Amulet
	.WORD AmuletText
					
;7 - Newspaper
	.WORD AliceAbanRoom
	.BYTE 80,174
	.WORD Newspaper
	.WORD NewspaperText	
					
;8 -Hammer
	.WORD 257			;no room at start
	.BYTE 80,216
	.WORD Hammer
	.WORD HammerText
					
;9 -Bunch of keys
	.WORD 257			;no room at start
	.BYTE 80,178
	.WORD BunchKeys
	.WORD BunchKeysText
	
;10-RubberBoots
	.WORD BennyCorridor3
	.BYTE 80,186
	.WORD RubberBoots
	.WORD RubberBootsText
	
;11-Gloves
	.WORD 257			;no room at start
	.BYTE 80,205
	.WORD Gloves
	.WORD GlovesText
								
;12-Lipstick
	.WORD 257
	.BYTE 80,179
	.WORD Lipstick
	.WORD LipstickText
	
;13-Extinguisher
	.WORD 257				;no room at start
	.BYTE 80,144
	.WORD Extinguisher
	.WORD ExtinguisherText
		
;14-LiftCard
	.WORD 257				;no room at start
	.BYTE 80,216
	.WORD LiftCard
	.WORD LiftCardText
	
;15-Lighter
	.WORD 257
	.BYTE 80,216
	.WORD Lighter
	.WORD LighterText
		
;16-ScrewDriver
	.WORD AliceStaircase
	.BYTE 72,243
	.WORD Screwdriver
	.WORD ScrewdriverText
			
;17-Magnet
	.WORD JoshCorridor1
	.BYTE 80,208
	.WORD Magnet
	.WORD MagnetText
	
;18-Cola can
	.WORD MyCorridor1
	.BYTE 80,164
	.WORD Colacan
	.WORD ColacanText
	
;19-Gramophone tube
	.WORD BallRoom
	.BYTE 80,61
	.WORD Tube
	.WORD TubeText
			
;20-Wine
	.WORD 257		;no room at start
	.BYTE 80,178
	.WORD Wine
	.WORD WineText										
	
;21-Angle
	.WORD BennyToilet
	.BYTE 72,245
	.WORD Angle
	.WORD AngleText
	
;22-Crowbar
	.WORD 257
	.BYTE 80,216
	.WORD Crowbar
	.WORD CrowbarText
	
;23-Lockpick
	.WORD MyBalcony2
	.BYTE 72,230
	.WORD Lockpick
	.WORD LockpickText
		
;24-Heavy brick
	.WORD 257		;no room at start
	.BYTE 80,194
	.WORD HeavyBrick
	.WORD HeavyBrickText
	
;25-Rope
	.WORD JoshToilet		
	.BYTE 80,174
	.WORD RopeItem
	.WORD RopeText
	
;26-Wire
	.WORD MansionEntrance
	.BYTE 80,218
	.WORD Wire
	.WORD WireText
	
;27-Pill
	.WORD 257
	.BYTE 80,212
	.WORD Pill
	.WORD PillText
	
;28-Dart
	.WORD 257
	.BYTE 72,188
	.WORD Dart
	.WORD DartText

;29-Modulator
	.WORD 257
	.BYTE 80,165
	.WORD Modulator
	.WORD ModulatorText
	
;30-Extended Ladder
	.WORD RoofTop03
	.BYTE 72,186
	.WORD ExtLadder
	.WORD ExtLadderText
	
;31-Bulb
	
	.WORD AliceCorridor3
	.BYTE 80,180
	.WORD Bulb
	.WORD BulbText
		
	
	
	.WORD 0			;end of items


;table containing	numbers of items located in current room and positions required to pick them
CurrentRoomItemTable
	.BYTE 0,0,0,0,0,0,0,0,0,0
	.BYTE 0,0,0,0,0,0,0,0,0,0
	.BYTE 0,0,0,0,0,0,0,0,0,0
	
	