;routines specific for each room, executed once when room is drawn are stored here

;------------				
MyToiletCode
;set fan data
	LD HL,FanStatus
	INC (HL)
	INC HL
	LD A,72
	LD (HL),A		;fan H
	INC HL
	LD A,115
	LD (HL),A		;fan L
	RET
	
;-----------------
AliceCorridor2Code
;type floor nr
	LD A,36
	JR TypeFloorText

;------------		
MyCorridor2Code
;type floor nr
	LD A,37
	JR TypeFloorText
	
;------------
BennyCorridor2Code	
;set fan data
	LD HL,FanStatus
	INC (HL)
	INC HL
	LD A,80
	LD (HL),A		;fan H
	INC HL
	LD A,43
	LD (HL),A		;fan L	
	
;type floor nr
	LD A,38
	JR TypeFloorText 

;------------	
TypeFloorText
	LD (FloorNr),A
	LD HL,18671	
	LD DE,FloorText
	PUSH HL
	CALL TypeText
	POP HL
	
;center text
	LD C,4
CenterLiftText1	
	PUSH HL	
	LD B,8
CenterLiftText2
	SCF
	CCF
	RR (HL)
	INC L
	RR (HL)		
	INC L
	RR (HL)
	DEC L		
	DEC L					;one line
	INC H
	DJNZ CenterLiftText2	;eight lines			
	POP HL
	DEC C 
	JR NZ,CenterLiftText1 	
	RET

;------------
MyCorridor1Code
	LD HL,20590
	LD DE,Nr666
	CALL TypeText
	RET
	
;------------
MyCorridor3Code
;draw flames if necessary
		
	LD A,(MyFlamesStatus)
	OR A
	JR NZ,DrawBrokenGlass		;no fire, do nothing
	
;set fire data
	LD DE,FireEdge
	LD HL,20647
	CALL DrawTile				;draw fire edge

;draw black space which blocks movement
	LD DE,BlackSpace
	LD HL,80*256+70
	CALL DrawTile
		
;fire data
	LD HL,FireStatus
	INC (HL)	
	INC HL
	LD A,128
	LD (HL),A					;fire position
	INC HL
	LD A,7
	LD (HL),A					;fire size	
		
;draws broken glass if necessary
DrawBrokenGlass	
	LD A,(ExtingStatus)
	CP 2
	RET NZ 						;glass not broken
;change glass attribute color
;by accident A=2, so no need LD A,2
	LD DE,23090					;D=90,5=50
	LD BC,258					;B=1,C=2
	CALL AttrBlock
	RET							

;---------------
MyHideoutCode
	LD A,(BoxesStatus)
	CP 2
	RET Z						;boxes blocking door removed
;draw boxes	
	LD HL,20504
	LD BC,3*256+3
	LD DE,Box01
	CALL TileBlock
	RET
	
;---------------		
MyStaircaseCode
	CALL DrawStairs
	
;set fan data
	LD HL,FanStatus
	INC (HL)
	INC HL
	LD A,72
	LD (HL),A			;fan H
	INC HL
	LD A,132
	LD (HL),A			;fan L	
	RET
DrawStairs
;draw stairs in upper part of screen
	LD HL,16617
	LD DE,Stairs02
	PUSH DE	
	CALL DrawTile
	POP DE
	LD HL,16583
	CALL DrawTile
	
	LD HL,16551
	LD DE,Border01
	LD B,3
	LD C,1
	CALL TileBlock
	RET
;----------------
AliceStaircaseCode
	CALL DrawStairs
;set flames data
	LD HL,FireStatus
	INC (HL)
	INC HL
	LD A,130
	LD (HL),A			;position
	INC HL
	LD A,28
	LD (HL),A			;size
	RET
;----------------
AliceCorridor3Code
;set fan data
	LD HL,FanStatus
	INC (HL)
	INC HL
	LD A,80
	LD (HL),A			;fan H
	INC HL
	LD A,59
	LD (HL),A			;fan L
	
;set "call help" text
;it means that this text MAY appear in this room and it will be checked,
;not that it will apear for sure
	LD HL,CallHelpRoomStatus
	INC (HL)
	INC HL;go to call help L
	LD A,170
	LD (HL),A
	RET
	
;----------------			
AliceAbanRoomCode
;set front tile
	LD HL,FrontTileStatus
	INC (HL)
	INC HL		
	LD A,32 			;tile number
	LD (HL),A
	INC HL
	LD A,180			;position
	LD (HL),A
	RET		
		
		
;--------------
BennyRoomCode
	LD A,(BennyStatus)
	CP 3				;check if benny left the room
	RET Z				;if he is gone, don't draw him
;didn't leave so draw him
	LD DE,Benny
	LD HL,20560			;Benny position
	CALL DrawTile
	RET
;-------------------------
AliceBedroomCode
	
	LD A,(AliceFireStatus)
	OR A						;are flames in this room still?
	JR NZ,AliceBedroomDrawGirl	;if not, don't draw them
	
;draw flames	
	LD DE,FireEdge2				;draw flames edges
	LD HL,20658
	PUSH DE
	CALL DrawTile
	POP DE
	LD HL,20649
	PUSH HL
	CALL DrawTile
	POP HL	
	LD BC,259;B=1,C=3
	CALL MirrorArea	
;draw black space which blocks movement
	LD DE,BlackSpace
	LD HL,80*256+74
	CALL DrawTile
	
	
;set flames data	
	LD HL,FireStatus
	INC (HL)
	INC HL
	LD A,138
	LD (HL),A					;position
	INC HL
	LD A,8
	LD (HL),A					;size
	
AliceBedroomDrawGirl
	LD A,(AliceStatus)
	CP 3						;is player carrying Alice with him
	RET Z						;if so, don't draw her
	
	LD HL,80*256+59
	LD DE,Girl
	CALL DrawTile
	
AliceBedroomHelp
	;set call help text
	LD HL,CallHelpRoomStatus
	INC (HL)
	INC HL;go to CALL help L
	LD A,250
	LD (HL),A	
	RET
	
;-----------------
JoshStaircaseCode
	LD A,(RopeStatus)
	OR A						;rope going to upper floor exists
	RET Z						;if not, don't draw it
	
	LD DE,Rope
	LD HL, 18473
	LD BC,1*256+10
	CALL TileBlock				;draw rope
	
	LD DE,22825
	LD BC,1*256+10
	LD A,70
	CALL AttrBlock
	RET

;-----------------
MansionEntranceCode
	LD A,(MansionDoorStatus)
	OR A						;is door boarded?
	RET NZ						;if not, don't draw plank
	
	LD HL,20589			;doors are boarded, draw plank
	LD DE,Plank
	CALL DrawTile
	RET

;-----------------
JoshCorridor1Code
;set fire burning
	;Draw fire edge
	LD DE,FireEdge
	LD HL,20664
	PUSH HL
	CALL DrawTile
	POP HL
	LD BC,259;B=1,C=3
	CALL MirrorArea	

	;SET fire data	
	LD HL,FireStatus
	INC (HL)
	INC HL
	LD A,153
	LD (HL),A;position
	INC HL
	LD A,7
	LD (HL),A;size	
	RET	
;--------------------
JoshCorridor2Code
		
	;SET fire burning 	
	;Draw fire edge
	LD DE,FireEdge
	LD HL,20644
	CALL DrawTile
		
	;SET fire data	
	LD HL,FireStatus
	INC (HL)
	INC HL
	LD A,128
	LD (HL),A;position
	INC HL
	LD A,4
	LD (HL),A;size	
		
	;type floor nr
	LD A,39
	JP TypeFloorText

;-----------------
JoshRoomCode
	LD A,1
	LD (BadWireRoomStatus),A	;this is the room with damaged wire
	RET
	
;-----------------
JoshToiletCode
;set fan data
	LD HL,FanStatus
	INC (HL)
	INC HL
	LD A,72
	LD (HL),A				;fan H
	INC HL
	LD A,103
	LD (HL),A				;fan L
	
;draw safe
	LD A,(SafeStatus)
	CP 4					;safe opened?
	JR Z,JoshToiletCode4
	
	PUSH AF
	LD HL,80*256+22		;draw closed safe
	LD DE,Safe1
	CALL DrawTile
	POP AF
	
	CP 2
	RET C					;status = 0 or 1 - end drawing
	
	JR NZ,JoshToiletCode3	

;status=2, draw newspaper
	LD HL,80*256+182
	LD DE,Newspaper2
	CALL DrawTile	
	RET
	
JoshToiletCode3
;status=3, draw flames
;set fire data	
	LD HL,SafeFireStatus	;set variable to be used by fire animation
	INC (HL)
	
	LD HL,80*256+150
	LD DE,SafeFireBottom
	CALL DrawTile
	RET
		
JoshToiletCode4	
	LD HL,80*256+22		;status=4
	LD DE,Safe2				;draw opened safe
	CALL DrawTile
	RET

;----
Safe1
	.BYTE 2,2
	.BYTE	127,191,192,220,219,215,205,201
	.BYTE	254,253,  3,123,187,219,107, 43
	.BYTE	207,201,205,215,219,192,191,127
	.BYTE	235, 43,107,219,187,  3,253,254
	.BYTE	  5,  5,  5,  5
	
Safe2
	.BYTE 2,2
	.BYTE	127,191,192,192,192,192,192,192
	.BYTE	254,253,  3,  3,  3,  3,  3,  3
	.BYTE	192,192,201,210,197,192,191,127
	.BYTE	  3,  3, 91,187,123,  3,253,254
	.BYTE	  5,  5,  5,  5
	
Newspaper2
	.BYTE 2,1
	.BYTE	  0,  0,  6, 25,  6, 55,123,205
	.BYTE	  0,  0,  0,160,112,184,220,238
	.BYTE	 71, 71
	
SafeFireBottom
	.BYTE 2,2	
	.BYTE	255,255,127,111,117, 47, 55, 63
	.BYTE	255,254,250,246,238,244,108,244
	.BYTE	 61, 31, 14, 21, 10,  5, 10,  0
	.BYTE	220,252,184, 80,168, 80,160,  0
	.BYTE	 66, 66, 66, 66
	
		
;-----------------
ReceptionCode
;set bat data
	LD HL,BatStatus
	INC (HL);set bat flag on
	INC HL
	LD A,108 ;L
	LD (HL),A
	INC HL
	LD A,80 ;H
	LD (HL),A
	INC HL
	LD A,48 ;cycles
	LD (HL),A
	INC HL
	LD (HL),A;current cycles
	INC HL
	LD A,0;direction
	LD (HL),A
	RET
;--------------
LibraryCode
	LD HL,BatStatus
	INC (HL);set bat flag on
	INC HL
	LD A,173 ;L
	LD (HL),A
	INC HL
	LD A,72  ;H
	LD (HL),A
	INC HL
	LD A,64  ;cycles
	LD (HL),A
	INC HL
	LD (HL),A;current cycles
	INC HL
	LD A,255;direction
	LD (HL),A
	RET
;-------------
MansionCor03Code
	LD HL,BatStatus
	INC (HL);set bat flag on
	INC HL
	LD A,132 ;L
	LD (HL),A
	INC HL
	LD A,80 ;H
	LD (HL),A
	INC HL
	LD A,64 ;cycles
	LD (HL),A
	INC HL
	LD (HL),A;current cycles
	INC HL
	XOR A;direction
	LD (HL),A
	RET
			
;-----------------
MansionCor01Code
;set zombie data
	LD A,(Zombie1Status)
	OR A
	RET NZ ;status<>0, zombie doesn't exist
	
	LD HL,ZombieStatus
	LD A,1
	LD (HL),A		;set zombie in this room
	INC HL
	LD A,46
	LD (HL),A		;zombie left walk edge
	INC HL
	LD A,60
	LD (HL),A		;zombie right walk edge
	INC HL
	LD A,255
	LD (HL),A		;zombie direction, zombie walking right
	INC HL
	LD A,52
	LD (HL),A		;zombie position
	
;color of zombie legs
	LD A,84
	CALL ColorZombieLegs
	RET
;------
ColorZombieLegs
;set zombie legs color	(changes attributes in 4 frames)
;it must be done because 2 zombies in the game walk on different floors
		
	LD HL,ZombieFrame1L
	LD DE,108
	LD B,4
ColorZombieLegs2
	ADD HL,DE
	LD (HL),A
	INC HL
	LD (HL),A
	INC HL
	DJNZ ColorZombieLegs2
	RET


;-----------------
MansionCor02Code
;set bat data
	LD HL,BatStatus
	INC (HL);set bat flag on
	INC HL
	LD A,105 ;L
	LD (HL),A
	INC HL
	LD A,80 ;H
	LD (HL),A
	INC HL
	LD A,48 ;cycles
	LD (HL),A
	INC HL
	LD (HL),A;current cycles
	INC HL
	LD A,0;direction
	LD (HL),A
	RET

;-----------------
Attic1Code
;set front tile
	LD HL,FrontTileStatus
	INC (HL)
	INC HL		
	LD A,119 			;tile number
	LD (HL),A
	INC HL
	LD A,168			;position
	LD (HL),A
	RET	

;-----------------
Attic2Code
;set zombie data	
	LD A,(Zombie2Status)
	OR A
	RET NZ ;status<>0, zombie doesn't exist
	
	LD HL,ZombieStatus
	LD A,1
	LD (HL),A		;set zombie in this room
	INC HL
	LD A,42
	LD (HL),A		;zombie left walk edge
	INC HL
	LD A,59
	LD (HL),A		;zombie right walk edge
	INC HL
	LD A,255
	LD (HL),A		;zombie direction, zombie walking right
	INC HL
	LD A,42
	LD (HL),A		;zombie position
	
	;color of zombie legs
	LD A,76
	CALL ColorZombieLegs
	RET
	

;-----------------
Attic3Code
;set front tile
	LD HL,FrontTileStatus
	INC (HL)
	INC HL		
	LD A,32 			;tile number
	LD (HL),A
	INC HL
	LD A,177			;position
	LD (HL),A
	RET	

;-----------------
SwimmingPoolCode
	LD A,1
	LD (AcidStatus),A
	RET


;-----------------
MyBalcony1Code
	LD A,(ExtendLadderStatus)
	OR A
	RET Z
;draw ladder	
	LD HL,80*256+10
	LD DE,ExtendedLadder
	LD BC,8*256+1
	CALL TileBlock
	RET
;----
ExtendedLadder
	.BYTE 2,1
	.BYTE	255,  0,255, 85,170,  0,255,252
	.BYTE	255,  0,255, 85,170,  0,255, 63
	.BYTE	 40, 40


;-----------------
RoofTop02Code
	LD A,(CarStatus)
	CP 2
	RET Z
;draw car
	LD HL,72*256+85
	LD DE,Car
	CALL DrawTile
	RET

;-----------------
;this code is used in places where bats move
;they would normally clear the objects dropped there
;so instead of dropping object this code is called
;which does nothing
DontDropItems
	RET











































































































































































