	DEVICE ZXSPECTRUM48
	ORG 23900
	
	
	
	
Start0
;immediately after loading the game move some graphic data to printer buffer
	LD HL,64768
	LD DE,23296
	LD BC,256
	LDIR
		

;Start of game	
Start
	DI	
	LD A,(Facing)
	CP 2							;facing left?
	CALL Z,MirrorPlayer				;if so, mirror all player's sprites
	
		
	
;clear game variables and player sprite buffer
;0 mean variable is set to its initial state	
	LD D,0
	LD HL,BackgroundBuffer
	LD BC,768		;3 buffers 256 bytes each
					;in buffer 192 bytes are player sprite, the rest are game variables							

					
ClearBuffers
	LD (HL),D
	INC HL
	DEC BC
	LD A,B
	OR C
	JR NZ,ClearBuffers
	
	
	LD SP,65534			;set stack address at the end of memory
						;last part of memory used by player sprite buffer which begins at end of memory-255 
						;and is 192 bytes big, that leaves 63 bytes for stack
	EI	
				

	CALL InitialiseItems	;copy initial items positions to their positions used in game
	
		
	JP StartMenu 		;go to game menu
;-------------------------
Start2	  
;the game jumps here when start game was chosen from menu	
	CALL ClearScreen				

;-------------------
;set some initial values 
	LD HL,20532
	;LD HL,72*256+8
	
	LD (OldPlayerPos),HL
	LD (NewPlayerPos),HL;position
	
	LD A,(Facing)
	CP 1							;facing left?
	CALL Z,MirrorPlayer				;if so, rotate all player's sprites
	
	LD A,1
	LD (Walking),A					;initially player is walking, flag set to 1	
	LD (SpriteInSequence),A			;position of player sprite in walking sequence (1-15)
	LD (SpriteFrame),A				;player sprite frame (1-4) 
	LD (Facing),A					;facing right
	LD A,96
	LD (PlayerEnergy),A
	
	;LD A,3
	;LD (AliceStatus),A				;temp!
	

	
;--------------------
;Draw first room
	CALL DrawMenu	
	LD HL,MyHome
	CALL DrawRoom
	
;Draw player in standing position for the first time
	;we can't call the usual player drawing routine as it restores the background from the buffer
	;which at the game start is empty
	CALL FirstStandInPlace
	
			
;---------CONTROL THE PLAYER---------
;------THE MAIN LOOP OF THE GAME-----		
				
MainLoop	
		CALL ChangeGameCycle		
		JR MainLoop2		
					
		LD BC,65022						;check item cheat
		IN A,(C)
		BIT 1,A							;letter "S" pressed
		CALL Z,ItemCheat
		
MainLoop2
																		 
		CALL GetPlayerInput

CheckSwap		
;Check if down(swaping items) is pressed
		BIT 2,A
		JR Z,CheckEvents;no down pressed
		CALL ChangeSelectedItem																;DOWN - CHANGE SELECTED ITEM
		JR Standing2
		
CheckEvents
		BIT 4,A;check if fire is pressed													ACTION (FIRE PRESSED)
		JR Z, CheckMoving;no fire pressed, so maybe walk
		
		CALL Events		;do different things like talking, walking doors,using items
		JR Standing2	;after that change player's frame to standing
		
CheckMoving		
		BIT 3,A;check jumping																JUMPING
		CALL NZ, Jump
		
		;no events and no jumping, so walking or standing
		LD A,(Joystick)
		AND 3; only 2 first bits are important
		OR A; checks if A=0 (standing)or A<>0 (walking)
		CALL NZ,Walk; goes to walking routine												WALKING
	

Standing
		LD A,(Joystick)
		; A=0 means no walking and no jumping so draw  player in standing position
		;if A<>0, player was moving and was already drawn so don't draw him in standing position
		OR A
		JR NZ,MainLoop
Standing2
		;draw player standing
		CALL StandInPlace																	;STAND
		JR MainLoop	
		
		
;------------------------------		
GetPlayerInput
	LD A,(GameControl)
	OR A						;keyboard or joystick
	JR Z,KeyboardControl
	
JoystickControl
	LD BC,31
	IN A,(C)
	LD (Joystick),A		
	RET
	
KeyboardControl
;the aim is to Set bits of A as it would be joystick input
	LD D,0
	LD BC,57342; O,P	
	IN A,(C)
	CPL
	AND 00000011B
	LD D,A
	LD BC,64510;Q
	IN A,(C)
	CPL
	AND 1
	RLA
	RLA
	RLA
	OR D		
	LD D,A		
	LD BC,65022;A
	IN A,(C)
	CPL
	AND 1
	RLA
	RLA
	OR D
	LD D,A
	LD BC,32766
	IN A,(C)
	CPL
	AND 1
	RLA
	RLA
	RLA
	RLA
	OR D ;ready
	LD (Joystick),A	
	RET	
		
		
		
		
		

		
;---------FILES-----------
	INCLUDE <Menu.asm>
	INCLUDE <Intro.asm>
	INCLUDE <DrawPlayer.asm>
	INCLUDE <DrawRoom.asm>
	INCLUDE <MovePlayer.asm>
	INCLUDE <Text.asm>
	INCLUDE <AnimObj.asm>
	INCLUDE <Events.asm>
	INCLUDE <Actions.asm>
	INCLUDE <Actions2.asm>
	INCLUDE <Actions3Lift.asm>
	INCLUDE <Items.asm>
	INCLUDE <RoomCode.asm>
	INCLUDE <Texts.asm>
	INCLUDE <Rooms.asm>
	INCLUDE <Graphic.asm>
	INCLUDE <Graphic2.asm>
	INCLUDE <GraphItems.asm>
	INCLUDE <BigPics.asm>
	INCLUDE <GraphPlayer.asm>
	INCLUDE <Flags.asm>

	SAVESNA "SoD.sna",Start0
	SAVEBIN "Sod.bin",23900,41124