;Routines connected to typing texts are placed here
		
	;-TypeText - types text	
	;-Letters contains letters graphic data
	;-Textbox - combines text with border
	;-DrawBox - draws border for text							

TypeText	
; This routine types text


;HL; contains position of text on screen
;DE contains text address IN memory
;BC is used		

	;Default text color is white on black
	LD A,71
	LD (TextColor),A
		
	LD (TextLineAd),HL
	
TypeText2	
	;Check if end of string
	LD A,(DE)
	AND A
	JR Z,	TextEnd ;end of text if zero
	
	CP 63; checks if should go to new line
	JR Z,TextNewLine
	CP 51; checks if color change
	JR Z,TextColorChange
	;letter attribute	
	PUSH HL
	LD A,80
	SRL H
	SRL H
	SRL H
	ADD A,H
	LD H,A
	LD A,(TextColor)
	LD (HL),A
	POP HL
	;draw A letter
	LD A,(DE)	;code of letter loaded
	LD BC,Letters-8;start of letters sprites
	
	;Count address of letter
	
	SLA A
	SLA A
	SLA A		;A=A*8 (with carry)to count adress of letter		
	
	PUSH HL
	LD HL,0
		
	LD L,A
	LD A,0
	ADC A,H	
	LD H,A	;HL=A*8	
	ADD HL,BC
	LD B,H
	LD C,L	;BC loaded with letter sprite address
	POP HL
		
				;address of printed letter placed IN BC
	
text2		
	PUSH HL
	PUSH DE
	LD E,8
text3	LD A,(BC)	;read letter data
	LD (HL),A	;AND print it IN screen		
	INC H
	INC BC	;go to another byte
	DEC E
	JR NZ, text3
	POP DE
	POP HL

;go to another letter			
	INC L	;next char on the screen
	INC DE ;next letter
	JR TypeText2
	
		
TextNewLine
	;this subroutine goes one line down	with text
	LD HL,(TextLineAd)	;beginning of current line IN HL
	CALL CountNextLine	;count address of one line down AND place it IN HL
	LD (TextLineAd),HL	;Update value
	INC DE			;Next letter
	JR TypeText2			;go to letter printing routine
	
TextColorChange
	INC DE
	LD A,(DE);read new color
	LD (TextColor),A; AND write it to proper cell			
	INC DE; go to next letter
	JR TypeText2		
TextEnd RET	
TextColor .BYTE 71; this cell stores text attribute
TextLineAd .WORD 16384;this 2 cells store screen address 
			   ;of currently printed text line (address of 1st char, to be exact)	

Letters
	;letters
	
	.BYTE	  0, 24, 60,102,102,126,102,102;a	1
	.BYTE	  0,124,102,102,124,102,102,124;b
	.BYTE	  0, 60,126, 98, 96, 98,126, 60;c
	.BYTE	  0,120,124,102,102,102,124,120;d
	.BYTE	  0,126,126, 96,124, 96,126,126;e
	.BYTE	  0,126,126, 96,124, 96, 96, 96;f
	.BYTE	  0, 60,126, 96,102, 98,126, 60;g
	.BYTE	  0,102,102,102,126,102,102,102;h
	.BYTE	  0, 24, 24, 24, 24, 24, 24, 24;i
	.BYTE	  0,  6,  6,  6,  6,102,126, 60;j
	
	.BYTE	  0,102,110,124,120,124,110,102;k	11
	.BYTE	  0, 96, 96, 96, 96, 96,126,126;l
	.BYTE	  0,198,238,254,254,214,198,198;m
	.BYTE	  0,198,230,246,254,222,206,198;n
	.BYTE	  0,124,254,198,198,198,254,124;o
	.BYTE	  0,124,126, 98, 98,124, 96, 96;p
	.BYTE	  0,124,254,198,214,214,254,124;q
	.BYTE	  0,124,126,102,102,124,110,102;r
	.BYTE	  0,124,254,192,124,  6,254,124;s
	.BYTE	  0,126,126, 24, 24, 24, 24, 24;t
	
	.BYTE	  0,102,102,102,102,102,126, 60;u	21
	.BYTE	  0,198,198,198,108,108, 56, 56;v
	.BYTE	  0,198,198,214,214,214,124, 40;w
	.BYTE	  0,198,238,124, 56,124,238,198;x
	.BYTE	  0,102,102,102, 60, 24, 24, 24;y
	.BYTE	  0,126,126, 12, 24, 48,126,126;z
	.BYTE	  0,	0,  0,  0,	0,  0,  0,	0;space
	.BYTE	  0,  0,  0,  0,  0, 96,240, 96;.
	.BYTE	  0, 96,240,240, 96, 96,  0, 96;!
	
	
	.BYTE	  0,124,254,198,198,198,254,124;0	30
	.BYTE	  0, 24, 56, 56, 24, 24, 60, 60;1
	.BYTE	  0, 60,126, 70, 12, 56,126,126;2
	.BYTE	  0, 60,126,  6, 28,  6,126, 60;3
	.BYTE	  0, 28, 60,108,204,252, 12, 12;4
	.BYTE	  0,126,126, 96,124,  6,102, 60;5
	.BYTE	  0, 60,126, 96,124,102,102, 60;6
	.BYTE	  0,126,126, 12, 24, 24, 48, 48;7
	.BYTE	  0,124,198,198,124,198,198,124;8
	.BYTE	  0, 60,102,102, 62,  6,102, 60;9
	

	.BYTE	  0,112,248,152, 48, 96,  0, 96;?
	.BYTE	  0, 99,103, 14, 28, 56,115, 99;%
	.BYTE     0,  2,  6, 14, 28, 56,112,224;/
	.BYTE	  0, 56,112, 96, 96, 96,112, 56;(
	.BYTE	  0, 14,103, 99,  3, 99,103, 14;:)
	.BYTE	  0,  0,  0,  0,254,254,  0,  0;-
	.BYTE	  0,108,124,120,112, 96,126,126;
	.BYTE	  0,  0,  0,  0,  0,  0,218,218;...
	.BYTE	  0, 56, 56, 48, 96, 64,  0,  0;'
	.BYTE	  0,204,204,204, 72, 72,  0,  0;"
	
	.BYTE	  0,  0,  0,  0, 48, 48, 32, 64;,
		  


;-----------------------

Textbox
;draw a textbox (border and text inside)
	;HL: left upper text box corner
	;BC: size,B=width,C=height
	;DE: memory address of text
		
	PUSH HL
	PUSH DE
	CALL DrawBox			;draw border
	POP DE
	POP HL
	CALL CountNextLine		;upper line is border,text begins in next line
	INC L					;first collumn is border,text begins in next collumn
	CALL TypeText
	CALL SoundA
	RET

	
;--------------------------
DrawBox
;draw an empty box with a border (for text or picture to be placed later)
	;HL: position of left upper box corner
	;BC: size,B=width,C=height
	;DE and IX are used
	;background color of box is fixed, the same as attribute of EmptySpace tile

;clear box area	
	PUSH BC				
	PUSH HL
	LD DE,EmptySpace		
	CALL TileBlock
	POP HL
	POP BC

;draw top edge	
	PUSH BC
	PUSH HL
	CALL DrawBoxHorizontallEdge
	POP HL
	POP BC
	
;draw bottom edge
	PUSH HL
	PUSH BC
	DEC C
DrawBox1
	CALL CountNextLine		;count address of bottom edge
	DEC C
	JR NZ, DrawBox1			;repeat C times to go C lines down
	POP BC
	PUSH BC
	CALL DrawBoxHorizontallEdge
	POP BC
	POP HL
	
;left and right edges
	PUSH BC
	PUSH HL
	DEC B	

DrawBox2
	PUSH HL	
	LD D,8					;8 pixel lines in character
		
DrawBox3
	PUSH HL					;draw left edge (merge with horizontal edges at the corners, that's why OR 102)
	LD A,(HL)
	OR 102					;01100110B (edge pattern)
	LD (HL),A				
		
	LD A,B
	ADD A,L
	LD L,A					;count address of right edge (HL+B where B = border width)
	LD A,(HL)
	OR 102
	LD (HL),A				;draw right edge	
	
	POP HL
	INC H					;next pixel line
	DEC D
	JR NZ,DrawBox3
		
	POP HL
	CALL CountNextLine		;go to next character line
	DEC C					;number of character lines left to do
	JR NZ,DrawBox2
		
	POP HL
	POP BC					;restore position and size (for text typing into box by next subroutine)
	RET		
		
DrawBoxHorizontallEdge
	LD IX,BoxHorizontalEdge
		
DrawBoxHorizontallEdge2	
	PUSH BC
	PUSH HL
	LD A,(IX+0)
	LD (HL),A ;line data (255 OR 0)
	
	;draw one line	
	LD D,H
	LD E,L
	INC E
	LD C,B
	LD B,0
	DEC C
	LDIR	
		
	POP HL
	POP BC	
		
	INC IX
	INC H
	
	LD A,H
	AND 7
	RET Z	;0 means that loop is repeated 8 times
			;(testing last 3 bits, 7=0111B, 8=1000B)
			;so it is time to finish it
	JR DrawBoxHorizontallEdge2

BoxHorizontalEdge 
	.BYTE 0, 255,255,0,0,255,255,0

;--------------------------	
CountNextLine
;HL: address of screen character line
;go line character line lower
	LD A,L
	ADD A,32
	LD L,A	;go to next line
	RET NC	;if no next screen segment,just return
		
	;go to next screen segment if necessary
	LD A,H
	ADD A,8
	LD H,A
	RET

	
;--------------------------
TypeMessage
;draw message,play sound and wait for key to clear message
	;A: number of message
		
;read data from message matrix
	LD B,A
	LD HL,MessageMatrix-6	
	LD DE,6	
FindMessageStart		
	ADD HL,DE
	DJNZ FindMessageStart		;find start of message data
		
	LD B,(HL)					;read message data	
	INC HL
	LD C,(HL)					;box size in BC
	INC HL
	LD E,(HL)
	INC HL			
	LD D,(HL)					;text address in DE
	INC HL
	PUSH DE
	LD D,(HL)
	INC HL
	LD E,(HL)
	EX DE,HL					;screen position in HL
	POP DE						;restore text address in DE
								
	CALL Textbox				;type text message
	
	;Now wait for pressing fire  clear the text
	
TypeMessage2	
	CALL GetPlayerInput
	BIT 4,A
	JR NZ,TypeMessageEnd
	JR TypeMessage2	
			
TypeMessageEnd	
	
	CALL SoundA					;restore room
	CALL RefreshCurrentRoom 
	
	RET 
	
